{
ALEA PROJEKTI
Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)
viimeksi muokattu: 23.5.2006
}
unit MetapalvelimenPorttiForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  //metapalvelimen portin vaihtolomake
  TFormMetapalvelimenPortti = class(TForm)
    EditMetapalvelimenPortti: TEdit;
    BitBtnVaihdaPortti: TBitBtn;
    BitBtnPeruuta: TBitBtn;
    procedure BitBtnVaihdaPorttiClick(Sender: TObject);
  private
    { Private declarations }
  public
    Portti: Integer;
    { Public declarations }
    procedure Alusta(Portti: Integer; Otsikko: String);
  end;

const Minimiportti: Integer = 0;
const Maksimiportti: Integer = 65535;

implementation

{$R *.dfm}

{ TFormMetapalvelimenPortti }

//alustetaan lomake
procedure TFormMetapalvelimenPortti.Alusta(Portti: Integer; Otsikko: String);
begin
  EditMetapalvelimenPortti.Text := IntToStr(Portti);
  Caption := Otsikko;
  Self.Portti := Portti;
end;

//tarkistetaan annetun portin oikeellisuus ja tehdn siit seuraavat toimenpiteet
procedure TFormMetapalvelimenPortti.BitBtnVaihdaPorttiClick(Sender: TObject);
var AnnettuPortti: Integer;
begin
  if(TryStrToInt(EditMetapalvelimenPortti.Text, AnnettuPortti)) then
  begin
    if((AnnettuPortti >= Minimiportti) and (AnnettuPortti <= Maksimiportti)) then
      Portti := AnnettuPortti
    else
      MessageDlg('Porttin numero tytyy olla vlilt [0, 65535]', mtWarning, [mbOK], 0);
  end
  else
    MessageDlg('Porttin numero tytyy olla vlilt [0, 65535]', mtWarning, [mbOK], 0);
end;

end.
