{
ALEA PROJEKTI
Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)
viimeksi muokattu: 23.5.2006
}

unit MetapalvelimenSalasanaForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  //metapalvelimen salasanan vaihto- ja lukituslomake 
  TFormMetapalvelimenSalasana = class(TForm)
    BitBtnVaihdaSalasana: TBitBtn;
    EditSalasana: TEdit;
    EditSalasanaUudelleen: TEdit;
    LabelSalasana: TLabel;
    LabelSalasanaUudelleen: TLabel;
    procedure BitBtnVaihdaSalasanaClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Salasana: String;
    Lukitus: Boolean;
    procedure Alusta(TekstinSyotto: String; TekstinSyotonMaksimipituus: Integer; Otsikko: String; VaihdaPainikkeenTeksti: String; Lukitus: Boolean);
  end;

implementation

{$R *.dfm}

//alustetaan lomake
procedure TFormMetapalvelimenSalasana.Alusta(TekstinSyotto: String; TekstinSyotonMaksimipituus: Integer; Otsikko: String; VaihdaPainikkeenTeksti: String; Lukitus: Boolean);
begin
  Self.Lukitus := Lukitus;
  
  //jos kyseess on lukitus piilotetaan turhat kentt
  if(Lukitus) then
  begin
    EditSalasanaUudelleen.Hide;
    LabelSalasanaUudelleen.Hide;
  end;

  BitBtnVaihdaSalasana.Caption := VaihdaPainikkeenTeksti;
  EditSalasana.Text := TekstinSyotto;
  EditSalasana.MaxLength := TekstinSyotonMaksimipituus;

  EditSalasanaUudelleen.Text := '';
  EditSalasanaUudelleen.MaxLength := TekstinSyotonMaksimipituus;
  Self.Salasana := Salasana;
  Caption := Otsikko;

end;

//tarkistetaan annettujen arvojen oikeellisuus ja tehdn siit seuraavat toimenpiteet
procedure TFormMetapalvelimenSalasana.BitBtnVaihdaSalasanaClick(Sender: TObject);
begin
  //jos on kyseess lukitus ollaan kiinnostuneet ainoastaan EditSalasanan sisllst
  if(Lukitus) then
  begin
    Salasana := Trim(EditSalasana.Text);
    ModalResult := mrOk;
  end
  //muuten tutkitaan ovatko annetut salasanat samat ja tehdn siit seuraavat toimenpiteet
  else
  begin
    if(EditSalasana.Text <> EditSalasanaUudelleen.Text) then
    begin
      ModalResult := mrCancel;
    end
    else
    begin
      Salasana := Trim(EditSalasana.Text);
      ModalResult := mrOk;
    end;
  end;
end;

end.
