// TALARIUS: Sislt olioiden/luokkien TpelilaudanObjekti,
// Tpelinappula, Thahmo toteutuksen.
//
// Tekijt:
//   Antti Kirjavainen (ajkirjav@iki.fi)
//   Jukka Miettinen (jupemiet@cc.jyu.fi)
//   Heikki Nevala (hemaneva@cc.jyu.fi)
//
{
ALEA PROJEKTI
Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)
viimeksi muokattu: 23.5.2006

Muutokset:
TPelilaudanObjekti: Listty property Pakollinen pakollisten pyshtymisien kyttn.
THahmo: muutettu kuvan paikalle kuvan polku, listty pelaajan verkkotiedot
(tunnus, IP, portti)
}


unit Objekti;

interface

uses Types, Graphics, ScktComp;

type

  TTyyppi = (ttUusiHeitto, ttSiirtyma, ttKysymys);

  // Pelilaudalle sijoiteltujen ruutu/objekti
  TPelilaudanObjekti = Class
    private
      FKoordinaatit: TPoint;
      FTyyppi: TTyyppi;
      FPakollinen: Boolean;
    public
      Constructor Create();
      Destructor Destroy; Override;
    published
      property Koordinaatit: TPoint read FKoordinaatit write FKoordinaatit;
      property Tyyppi: TTyyppi read FTyyppi write FTyyppi;
      //Onko ruutuun pakko pyshty
      property Pakollinen: Boolean read FPakollinen write FPakollinen;
    end;

  // Pelinappula, joka liikkuu pelilaudalla
  TPelinappula = Class
    private
      FKoordinaatit: TPoint;
      FID: Integer;
      FPaikka: Integer;
      FMaalissa: Boolean;
      FNimi: String;
    public
      Constructor Create();
      Destructor Destroy; Override;
    published
      property Koordinaatit: TPoint read FKoordinaatit write FKoordinaatit;
      property ID: Integer read FID write FID;
      property Paikka: Integer read FPaikka write FPaikka;
      property Maalissa: Boolean read FMaalissa write FMaalissa;
      property Nimi: String read FNimi write FNimi;
    end;

  // Hahmo sislt pelaajan tiedot.
  THahmo = Class
    private
      FNimi: String;
      FKuvanPolku: String;
      FTunnus: String;
//      FSaie: TCustomWinSocket;
      FIPOsoite: String;
      FPortti: Integer;
    public
      Constructor Create();
      Destructor Destroy; Override;
    published
      property Nimi: String read FNimi write FNimi;
      property KuvanPolku: String read FKuvanPolku write FKuvanPolku;
      property Tunnus: String read FTunnus write FTunnus;
//      property Saie: TCustomWinSocket read FSaie write FSaie; //pelaajan yhteyden sie //poistettu kytst: teki hahmot poistamattomiksi
      property IPOsoite: String read FIPOsoite write FIPOsoite; //IP nettipeliin
      property Portti: Integer read FPortti write FPortti; //portti nettipeliin
    end;

implementation

{ TPelilaudanObjekti }

constructor TPelilaudanObjekti.Create;
begin
  inherited;

end;

destructor TPelilaudanObjekti.Destroy;
begin
  inherited;
end;

{ TPelinappula }

constructor TPelinappula.Create;
begin
  inherited;
  //
end;

destructor TPelinappula.Destroy;
begin
  //
  inherited;
end;

{ THahmo }

constructor THahmo.Create;
begin
  inherited;
  //
end;

destructor THahmo.Destroy;
begin
  inherited;
end;

end.
