{
  TALARIUS: Pelilaudan tekeminen

  Antti Kirjavainen (ajkirjav@iki.fi)
  Jukka Miettinen (jupemiet@cc.jyu.fi)
  Heikki Nevala (hemaneva@cc.jyu.fi)

  Viimeksi muokattu: 16.2.2006

}

{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
{$WARN SYMBOL_DEPRECATED ON}
{$WARN SYMBOL_LIBRARY ON}
{$WARN SYMBOL_PLATFORM ON}
{$WARN UNIT_LIBRARY ON}
{$WARN UNIT_PLATFORM ON}
{$WARN UNIT_DEPRECATED ON}
{$WARN HRESULT_COMPAT ON}
{$WARN HIDING_MEMBER ON}
{$WARN HIDDEN_VIRTUAL ON}
{$WARN GARBAGE ON}
{$WARN BOUNDS_ERROR ON}
{$WARN ZERO_NIL_COMPAT ON}
{$WARN STRING_CONST_TRUNCED ON}
{$WARN FOR_LOOP_VAR_VARPAR ON}
{$WARN TYPED_CONST_VARPAR ON}
{$WARN ASG_TO_TYPED_CONST ON}
{$WARN CASE_LABEL_RANGE ON}
{$WARN FOR_VARIABLE ON}
{$WARN CONSTRUCTING_ABSTRACT ON}
{$WARN COMPARISON_FALSE ON}
{$WARN COMPARISON_TRUE ON}
{$WARN COMPARING_SIGNED_UNSIGNED ON}
{$WARN COMBINING_SIGNED_UNSIGNED ON}
{$WARN UNSUPPORTED_CONSTRUCT ON}
{$WARN FILE_OPEN ON}
{$WARN FILE_OPEN_UNITSRC ON}
{$WARN BAD_GLOBAL_SYMBOL ON}
{$WARN DUPLICATE_CTOR_DTOR ON}
{$WARN INVALID_DIRECTIVE ON}
{$WARN PACKAGE_NO_LINK ON}
{$WARN PACKAGED_THREADVAR ON}
{$WARN IMPLICIT_IMPORT ON}
{$WARN HPPEMIT_IGNORED ON}
{$WARN NO_RETVAL ON}
{$WARN USE_BEFORE_DEF ON}
{$WARN FOR_LOOP_VAR_UNDEF ON}
{$WARN UNIT_NAME_MISMATCH ON}
{$WARN NO_CFG_FILE_FOUND ON}
{$WARN MESSAGE_DIRECTIVE ON}
{$WARN IMPLICIT_VARIANTS ON}
{$WARN UNICODE_TO_LOCALE ON}
{$WARN LOCALE_TO_UNICODE ON}
{$WARN IMAGEBASE_MULTIPLE ON}
{$WARN SUSPICIOUS_TYPECAST ON}
{$WARN PRIVATE_PROPACCESSOR ON}
{$WARN UNSAFE_TYPE OFF}
{$WARN UNSAFE_CODE OFF}
{$WARN UNSAFE_CAST OFF}
unit PelilaudanTekoPaaForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Menus, ExtCtrls, Contnrs, IniFiles, StrUtils,
  JPEG, ExtDlgs;

type
  TValittuObjekti = (voUusiHeitto, voSiirtyma, voKysymys);
  TTaustanAsettelu = (taNormaali, taVenytetty, taVierekkain);

  TFormPelilaudanTeko = class(TForm)
    PanelToiminnot: TPanel;
    PanelPelilauta: TPanel;
    MainMenu: TMainMenu;
    MenuTiedosto: TMenuItem;
    MenuAsetukset: TMenuItem;
    MenuOhje: TMenuItem;
    MenuLopeta: TMenuItem;
    PanelVihje: TPanel;
    Taustakuva: TImage;
    MenuVaihdaTaustakuva: TMenuItem;
    LataaTaustaDialog_OLD: TOpenDialog;
    PopupMenu: TPopupMenu;
    PopupPoistaRuutu: TMenuItem;
    PopupMenuTyyppi: TMenuItem;
    UusiHeitto: TMenuItem;
    Siirtyma: TMenuItem;
    Kysymys: TMenuItem;
    MenuLataaPelilauta: TMenuItem;
    MenuUusi: TMenuItem;
    MenuTallenna: TMenuItem;
    PanelNappulat: TPanel;
    OpenDialogLataaPelilauta: TOpenDialog;
    OpenDialogLiitaKysymyssarja: TOpenDialog;
    MenuTallennaNimella: TMenuItem;
    SaveDialogTallennaPelilauta: TSaveDialog;
    MenuTietojaOhjelmasta: TMenuItem;
    LabelVihje: TLabel;
    PanelTyokalupalkki: TPanel;
    Tyokalupalkki: TGroupBox;
    LabelKysymyssarjanSijainti: TLabel;
    BitBtnUusi: TBitBtn;
    BitBtnAvaa: TBitBtn;
    BitBtnTallenna: TBitBtn;
    BevelErotin: TBevel;
    BitBtnVaihdaTaustakuva: TBitBtn;
    BitBtnLiitaKysymyssarja: TBitBtn;
    LabelKysymyssarja: TLabel;
    BevelToinenErotin: TBevel;
    Liitkysymyssarja: TMenuItem;
    SpeedButtonUusiHeitto: TSpeedButton;
    SpeedButtonSiirtyma: TSpeedButton;
    SpeedButtonKysymys: TSpeedButton;
    LataaTaustaDialog: TOpenPictureDialog;
    BitBtnPoistaRuudut: TBitBtn;
    procedure BitBtnUusiHeittoClick(Sender: TObject);
    procedure TaustakuvaMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure BitBtnSiirtymaClick(Sender: TObject);
    procedure BitBtnKysymysClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure TaustakuvaDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PanelPelilautaCanResize(Sender: TObject; var NewWidth, NewHeight: Integer; var Resize: Boolean);
    procedure MenuVaihdaTaustakuvaClick(Sender: TObject);
    procedure PopupPoistaRuutuClick(Sender: TObject);
    procedure PopupMenuPopup(Sender: TObject);
    procedure SiirtymaClick(Sender: TObject);
    procedure UusiHeittoClick(Sender: TObject);
    procedure KysymysClick(Sender: TObject);
    procedure MenuUusiClick(Sender: TObject);
    procedure MenuLataaPelilautaClick(Sender: TObject);
    procedure MenuLopetaClick(Sender: TObject);
    procedure MenuTallennaClick(Sender: TObject);
    procedure MenuLiitaKysymyssarjaClick(Sender: TObject);
    procedure MenuTallennaNimellaClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PanelVihjeResize(Sender: TObject);
    procedure BitBtnUusiClick(Sender: TObject);
    procedure BitBtnAvaaClick(Sender: TObject);
    procedure BitBtnTallennaClick(Sender: TObject);
    procedure PanelTyokalupalkkiCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure BitBtnPoistaRuudutClick(Sender: TObject);

  private
    Valittu: TValittuObjekti;
    ObjektiLista: TObjectList;
    KuvaLista: TObjectList;
    TaustaBitmap: TBitmap; // Pohjataustakuva (ilman viivoja) thn plle sitten viivat
    Raahattava: Integer;
    PelilaudanNimi: String;
    OnkoPelilautaaMuutettu: Boolean;
    Kysymyssarja: String;
    TaustakuvanPolku: String;
    OletusTaustakuva: String;
    UusiHeittoKuvanPolku: String;
    SiirtymaKuvanPolku: String;
    KysymysKuvanPolku: String;
    TaustanAsettelu: TTaustanAsettelu;

    procedure TyhjennaPelilauta();
    procedure PaivitaTausta(TaustanPolku: String);
    procedure PaivitaViivat();
    procedure ErotaPolkuNimiJaPaate(s: String; var Polku, Nimi, Paate: String);
    procedure SovitaPanelToiminnot;

  public
    procedure AsetaTaustakuva(Asettelu: TTaustanAsettelu);

  end;

var
  FormPelilaudanTeko: TFormPelilaudanTeko;

implementation

uses Objekti, TaustakuvanAsettaminenForm,MedioidenLataajat;

const MinimiTaustanLeveys: Integer = {653}800;
const MinimiTaustanKorkeus: Integer = {544}600;
const TaustakuvanVakionimi = 'pelilaudantausta.bmp';

{$R *.dfm}

procedure TFormPelilaudanTeko.FormCreate(Sender: TObject);
//var
//  Tausta: TPicture;
begin
  // Synnytetn formi keskelle ruutua
  Left := (Screen.Width div 2) - (Width div 2);
  Top := (Screen.Height div 2) - (Height div 2);

  ObjektiLista := TObjectList.Create;
  KuvaLista := TObjectList.Create;
  Valittu := voUusiHeitto; // uusi heitto oletuksena valittuna
  UusiHeitto.Checked := true; // -- " --

 // Tausta := TPicture.Create;
 // TaustakuvanPolku := 'C:\MyTemp\GameLab\TALARIUS_TEKO\Kuvat\Tausta.bmp';
 // OletusTaustakuva := TaustakuvanPolku; // tallennetaan oletustaustakuva
 // LataaKuva(Tausta, TaustakuvanPolku); // ladataan taustakuva

  // Mritelln taustakuva 
  TaustakuvanPolku := ExtractFilePath(application.ExeName) + 'Kuvat\Talariuslauta3.bmp';
  PaivitaTausta(TaustakuvanPolku);
  Oletustaustakuva:=TaustakuvanPolku;

  UusiHeittoKuvanPolku := ExtractFilePath(application.ExeName) + 'Kuvat\uusi_heitto.bmp';
  SiirtymaKuvanPolku := ExtractFilePath(application.ExeName) + 'Kuvat\siirtyma.bmp';
  KysymysKuvanPolku := ExtractFilePath(application.ExeName) + 'Kuvat\kysymys2.bmp';
  //UusiHeittoKuvanPolku := 'C:\MyTemp\GameLab\TALARIUS_TEKO\Kuvat\uusi_heitto.bmp';
  //SiirtymaKuvanPolku := 'C:\MyTemp\GameLab\TALARIUS_TEKO\Kuvat\siirtyma.bmp';
  //KysymysKuvanPolku := 'C:\MyTemp\GameLab\TALARIUS_TEKO\Kuvat\kysymys2.bmp';

 // TaustaBitmap := Tausta.Bitmap;

  Taustakuva.Top := 0;
  Taustakuva.Left := 0;
 // Taustakuva.Picture := Tausta;

  // Mitn objektia ei ole viel raahattu
  Raahattava := -1;

  PelilaudanNimi := ''; // Pelilaudalle ei ole annettu viel nime
  Kysymyssarja := ''; // Kysymyssarjaa ei ole viel liitetty

  OnkoPelilautaaMuutettu := false;
//  BitBtnUusiHeitto.SetFocus;
end;

procedure TFormPelilaudanTeko.TaustakuvaMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  UusiObjekti: TPelilaudanObjekti; // Varsinainen tietorakenne
  ObjektinKuva: TPicture; // Apumuuttuja, johon ladataan pelilaudalle listtv
                          // kuva ja asetetaan sitten myhemmin kuvakomponentille
  KuvaKomponentti: TImage; // Nkyville objekteille (pelilaudan ruuduille)
begin

  // Jos ei olla lismss uutta objektia vaan halutaan liikuttaa objektia
  if ( TImage(Sender).Width  < 70 ) then begin
    Raahattava := KuvaLista.IndexOf(Sender);
  end

  // Muuten listn uusi objekti
  else begin

    UusiObjekti := TPelilaudanObjekti.Create;
    ObjektinKuva := TPicture.Create;

    // Jos on valittu "Uusi heitto"
    if ( Valittu = voUusiHeitto ) then begin
      UusiObjekti.Tyyppi := ttUusiHeitto;
      LataaKuva(ObjektinKuva,UusiHeittoKuvanPolku);
    end

    // Jos on valittu "Siirtym"
    else if ( Valittu = voSiirtyma ) then begin
      UusiObjekti.Tyyppi := ttSiirtyma;
      LataaKuva(ObjektinKuva,SiirtymaKuvanPolku);
    end

    // Jos on valittu "Kysymys"
    else if ( Valittu = voKysymys ) then begin
      UusiObjekti.Tyyppi := ttKysymys;
      LataaKuva(ObjektinKuva,KysymysKuvanPolku);
    end;

    // Luodaan KuvaKomponentti PanelPelilaudalle
    KuvaKomponentti := TImage.Create(PanelPelilauta);

    // Asetaan kuvan keskikohta hiiren osoittamaan paikkaan
    UusiObjekti.Koordinaatit := Point(X - (ObjektinKuva.Height div 2), Y - (ObjektinKuva.Width div 2));

    // Listn objekti objektilistaan
    ObjektiLista.Add(UusiObjekti);

    // Kuvakomponentin paikka

    KuvaKomponentti.Top := UusiObjekti.Koordinaatit.Y;
    KuvaKomponentti.Left := UusiObjekti.Koordinaatit.X;

    // Kuvakomponentin leveys ja korkeus
    KuvaKomponentti.Width := ObjektinKuva.Width;
    KuvaKomponentti.Height := ObjektinKuva.Height;

    // Asetetaan ruudun kuva kuvakomponenttiin
    KuvaKomponentti.Picture := ObjektinKuva;

    // Kuvan raahaamista varten
    KuvaKomponentti.DragMode := dmAutomatic;

    KuvaLista.Add(KuvaKomponentti); 

    // Asetetaan tarvittavat attribuutit
    KuvaKomponentti.Parent := PanelPelilauta;
    KuvaKomponentti.Transparent := true;
    KuvaKomponentti.PopupMenu := PopupMenu;

    // Piirretn viiva listyn ja edellisen rudun vliin, jos edellinen ruutu on olemassa.

    if ( ObjektiLista.Count = 1 ) then begin
      // ainoastaan yksi objekti pelilaudalla
      Taustakuva.Canvas.MoveTo(X,Y);
    end
    else begin
      // useita objekteja, yhdistetn ne viivoilla
      Taustakuva.Canvas.LineTo(X,Y);
    end;

    ObjektinKuva.Free; // vapautetaan ObjektinKuva
                       

    OnkoPelilautaaMuutettu := true;

    // pivitetn viivat ja samalla alku- ja loppupisteet tulee kohdalleen
    PaivitaViivat();
  end;
end;

procedure TFormPelilaudanTeko.BitBtnUusiHeittoClick(Sender: TObject);
begin
  Valittu := voUusiHeitto;
end;

procedure TFormPelilaudanTeko.BitBtnSiirtymaClick(Sender: TObject);
begin
  Valittu := voSiirtyma;
end;

procedure TFormPelilaudanTeko.BitBtnKysymysClick(Sender: TObject);
begin
  Valittu := voKysymys;
end;

procedure TFormPelilaudanTeko.FormDestroy(Sender: TObject);
begin
  ObjektiLista.Free;
  KuvaLista.Free;
end;

procedure TFormPelilaudanTeko.FormDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin

  // Lhdetn siit, ett vri juttuja raahataan
  Accept := False;

  // Tarkistetaan, ett komponentti, jolle raahataan on kuva...
  if ( Sender is TImage ) then begin

  // ja ett mys raahattava on kuva...
    if ( Source is TImage ) then begin

      // ja yksi ruutukuvista
      if ( KuvaLista.IndexOf(Source) > -1 ) then begin

        // ja ett se komponentti, jolle raahataan, on taustakuva
        // (verrataan olioita) 

        //if ( TImage(Sender).Width = TaustaBitmap.Width ) then begin
        if (TImage(Sender)=Taustakuva) then begin

          // silloin raahaamisen voi sallia.
          Accept := True;
        end;
      end;
    end;
  end;
end;

procedure TFormPelilaudanTeko.TaustakuvaDragDrop(Sender, Source: TObject;
  X, Y: Integer);
var
  Index: Integer;
begin

// sama rakenne kuin OnDragOverissa.

  if ( Sender is TImage ) then begin
    if ( Source is TImage ) then begin
      Index := KuvaLista.IndexOf(Source);
      if ( Index > -1 ) then begin
        if ( TImage(Sender)=Taustakuva ) then begin

          // otetaan koordinaatit siit kohtaa miss kyttj pst objektin irti
          TPelilaudanObjekti(Objektilista.Items[Index]).Koordinaatit := Point(X - (TImage(Source).Height div 2), Y - (TImage(Source).Width div 2));

          // kuva asetaan koordinaattien osoittamaan paikkaan
          TImage(Source).Top := TPelilaudanObjekti(Objektilista.Items[Index]).Koordinaatit.Y;
          TImage(Source).Left := TPelilaudanObjekti(Objektilista.Items[Index]).Koordinaatit.X;

          PaivitaViivat();

          OnkoPelilautaaMuutettu := true;

        end;
      end;
    end;
  end;

end;


procedure TFormPelilaudanTeko.PaivitaViivat;
var
  i,j,x,y: Integer;
begin
  Taustakuva.Canvas.Brush.Bitmap := TaustaBitmap;
  Taustakuva.Canvas.FillRect(Taustakuva.Canvas.ClipRect);

  if ( KuvaLista.Count <= 0 ) then exit; // Voidaan lhte pois jos ei ole yhtn objektia piirrettvn


  // Piirretn kaikki kahteen kertaan, ett saadaan paremmat viivat
  for j:=1 to 2 do begin // Piirretn kaikki kahteen kertaan, jotta
                         // saadaan mustalla reunustetut viivat, joissa
                         // on valkoinen viiva keskell (nin viivat
                         // nkyvt kaikenlaisilla taustoilla

    // ensimmist kuvaa varten tarvitaan koordinaatit jo ennen silmukkaa
    x := TPelilaudanObjekti(ObjektiLista.Items[0]).Koordinaatit.X;
    y := TPelilaudanObjekti(ObjektiLista.Items[0]).Koordinaatit.Y;
    Taustakuva.Canvas.MoveTo(x + (TImage(KuvaLista.Items[0]).Width div 2), y + (TImage(KuvaLista.Items[0]).Height div 2));

    // kydn kuvat lpi ja otetaan koordinaatit talteen
    for i:=0 to KuvaLista.Count-1 do begin
      x := TPelilaudanObjekti(ObjektiLista.Items[i]).Koordinaatit.X;
      y := TPelilaudanObjekti(ObjektiLista.Items[i]).Koordinaatit.Y;

      // Jos halutaan viimeisen ruudun ymprille neli:
      if ( i = KuvaLista.Count-1 ) then begin
        Taustakuva.Canvas.Rectangle(x,y,x + TImage(KuvaLista.Items[i]).Width,y + TImage(KuvaLista.Items[i]).Height);
      end;

      // Jos halutaan ensimmisen ruudun ymprille neli:
      if ( i = 0 ) then begin
        Taustakuva.Canvas.Pen.Color := clRed;
        Taustakuva.Canvas.Rectangle(x,y,x + TImage(KuvaLista.Items[i]).Width,y + TImage(KuvaLista.Items[i]).Height);
      end;

    // viiva edellisest objektista nykyiseen
      if j=2 then begin
        Taustakuva.Canvas.Pen.Width:=2;
        Taustakuva.Canvas.Pen.Color := clBlack;
      end else begin
        Taustakuva.Canvas.Pen.Width:=4;
        Taustakuva.Canvas.Pen.Color := clWhite;
      end;

    Taustakuva.Canvas.LineTo(x + (TImage(KuvaLista.Items[i]).Width div 2), y + (TImage(KuvaLista.Items[i]).Height div 2));
  end;
  end;
end;

procedure TFormPelilaudanTeko.PanelPelilautaCanResize(Sender: TObject;
  var NewWidth, NewHeight: Integer; var Resize: Boolean);
begin
  // pakotetaan formi taustakuvan kokoiseksi
  // Ts. formin kokoa ei voida siis muuttaa venyttmll tms, koska aina
  // pakotetaan kuvan kokoiseksi
  NewWidth := Taustakuva.Width;
  NewHeight := Taustakuva.Height;
  Resize := True;
end;

procedure TFormPelilaudanTeko.MenuVaihdaTaustakuvaClick(Sender: TObject);
var
  UusiTausta: TPicture;
  f: TFormTaustanAsettaminen;
  i, j: Integer;
begin
  // Jos kyttj painoi Cancelia niin lhdetn pois!
  if not LataaTaustaDialog.Execute then exit;

  // luodaan formi
  f := TFormTaustanAsettaminen.Create(nil);

  if ( f.ShowModal = mrOK ) then begin

    UusiTausta := TPicture.Create;
    TaustaKuva.Picture := UusiTausta; // Tm rivi hyv olla olemassa:
                                      // bugittaa kummasti jos ei ole.
                                      // Esim. voi vain laittaa kerran
                                      // taustakuvan venytetyksi tai vierekkin,
                                      // seuraavilla kerroilla muutos ei en
                                      // vlity..
    TaustakuvanPolku := LataaTaustaDialog.FileName;
    LataaKuva(UusiTausta,TaustakuvanPolku);
    //TaustaBitmap := UusiTausta.Bitmap;
    TaustaBitmap.Assign(UusiTausta.Graphic); // TaustanBitmapiksi ladattu kuva
                                             // **Onko tm edes tarpeellinen?

    Taustakuva.Top := 0;
    Taustakuva.Left := 0;

    // Normaali
    // Hvitt ruudut, jos liian pieni taustakuva (olkoon tm tss ominaisuus)
    if ( TaustanAsettelu = taNormaali ) then begin
      //Taustakuva.Picture := UusiTausta;
      Taustakuva.AutoSize := false;
      Taustakuva.Width := UusiTausta.Width;
      Taustakuva.Height := UusiTausta.Height;
      Taustakuva.Stretch := false;
      // Tytetn taustakuvan bitmap... Assign ei tee sit (nkjn...)
      Taustakuva.Picture.Bitmap.Height:=UusiTausta.Height;
      Taustakuva.Picture.Bitmap.Width:=UusiTausta.Width;
      Taustakuva.Canvas.Draw(0,0,Uusitausta.Graphic);
      Uusitausta.Bitmap.Height:=Taustakuva.Height;
      Uusitausta.Bitmap.Width:=Taustakuva.Width;
      Uusitausta.Bitmap.Canvas.Draw(0,0,Taustakuva.Picture.Graphic);
      TaustaBitmap := UusiTausta.Bitmap;
    end

    // Venytetty
    else if ( TaustanAsettelu = taVenytetty ) then begin
      Taustakuva.AutoSize := false;
      Taustakuva.Width := MinimiTaustanLeveys;
      Taustakuva.Height := MinimiTaustanKorkeus;
      // Asetetaan bitmapille uudet mitat --> vaikuttaa picturen ominaisuuksiin
      // Jos tt ei tehtisi, niin silloin piirrettisiin vain pelkstn
      // kuvan alalle...
      Taustakuva.Picture.Bitmap.Height:=MinimiTaustanKorkeus;
      Taustakuva.Picture.Bitmap.Width:=MinimiTaustanLeveys;
      // Venytetn kuva canvakselle
      Taustakuva.Canvas.StretchDraw(Rect(0,0,Taustakuva.Width,Taustakuva.Height),Uusitausta.Graphic);
      // Korvataan uusitausta juuri venytetyll kuvalla ja asetetaan se
      // tyhjksi taustaksi, jonka plle viivat piirtyvt. Tllainen
      // kopiointi tehdn taustakuvan tallennusmekanismin takia. Jos ei
      // tehtisi ja asetettaisiin vain osoitin:
      // TaustaBitmap := Taustakuva.Picture.Bitmap, niin silloin viivat
      // tallentuisivat taustakuvaan mukaan. Ei hyv, kun ladataan lauta
      // editoitavaksi ja aletaan siirtelemn ruutuja...
      Uusitausta.Bitmap.Height:=Taustakuva.Height;
      Uusitausta.Bitmap.Width:=Taustakuva.Width;
      Uusitausta.Bitmap.Canvas.Draw(0,0,Taustakuva.Picture.Graphic);
      TaustaBitmap := Uusitausta.Bitmap;
    end

    // Vierekkin
    else if ( TaustanAsettelu = taVierekkain ) then begin
      Taustakuva.AutoSize := false;
      Taustakuva.Width := MinimiTaustanLeveys;
      Taustakuva.Height := MinimiTaustanKorkeus;
      Taustakuva.Stretch := false;

      i := 0;
      j := 0;
      TaustaKuva.Canvas.CopyMode := cmSrcCopy;

      // korkeussuunnassa..
      While ( UusiTausta.Height * i < Taustakuva.Height ) do begin

      // leveyssuunnassa..
        While ( UusiTausta.Width * j < Taustakuva.Width  ) do begin

          // piirretn kuvia vierekkin ja allekain niin monta kuin mahtuu
          TaustaKuva.Canvas.Draw( UusiTausta.Width * j, UusiTausta.Height * i, UusiTausta.Graphic);
          j := j + 1;
        end;

        i := i + 1;
        j := 0;
      end;

      // Tehdn kuvan kopiointi samasta syyst kuin yll
      Uusitausta.Bitmap.Height:=Taustakuva.Height;
      Uusitausta.Bitmap.Width:=Taustakuva.Width;
      Uusitausta.Bitmap.Canvas.Draw(0,0,Taustakuva.Picture.Graphic);
      TaustaBitmap := Uusitausta.Bitmap;

    end;

    

    // Sovitetaan toiminnot paneeli oikean kokoiseksi
    SovitaPanelToiminnot;
    // tt pit kutsua ett paneeli osaa asetella itsens uudestaan
    // PanelVihjeResize(Self);

    OnkoPelilautaaMuutettu := true;
    PaivitaViivat;
  end;
end;

procedure TFormPelilaudanTeko.PopupPoistaRuutuClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := KuvaLista.IndexOf(TObject(PopupMenu.PopupComponent));
  ObjektiLista.Delete(Index);
  KuvaLista.Delete(Index);

  PaivitaViivat;

  // objekti poistettu -> pelilautaan tuli muutos
  OnkoPelilautaaMuutettu := true;
end;

procedure TFormPelilaudanTeko.PopupMenuPopup(Sender: TObject);
var
  Index: Integer;
begin
  // Selvitetn mit komponenttia klikattiin hiiren oikealla nppimell
  Index := KuvaLista.IndexOf(TObject(PopupMenu.PopupComponent));

  // uusi heitto
  if ( TPelilaudanObjekti(ObjektiLista.Items[Index]).Tyyppi = ttUusiHeitto ) then begin
    UusiHeitto.Checked := true; // valittu
    Siirtyma.Checked := false;
    Kysymys.Checked := false;
  end

  // siirtym
  else if ( TPelilaudanObjekti(ObjektiLista.Items[Index]).Tyyppi = ttSiirtyma ) then begin
    UusiHeitto.Checked := false;
    Siirtyma.Checked := true; // valittu
    Kysymys.Checked := false;
  end

  // kysymys
  else if ( TPelilaudanObjekti(ObjektiLista.Items[Index]).Tyyppi = ttKysymys ) then begin
    UusiHeitto.Checked := false;
    Siirtyma.Checked := false;
    Kysymys.Checked := true; // valittu
  end
end;

procedure TFormPelilaudanTeko.UusiHeittoClick(Sender: TObject);
var
  Index: Integer;
  ObjektinKuva: TPicture;
begin
  if UusiHeitto.Checked then exit; // jos uusi heitto on jo valittu, lhdetn pois!

  // saadaan tieto siit, mit kuvaa klikattiin hiirell
  Index := KuvaLista.IndexOf(TObject(PopupMenu.PopupComponent));
  TPelilaudanObjekti(ObjektiLista.Items[Index]).Tyyppi := ttUusiHeitto;

  ObjektinKuva := TPicture.Create;
  LataaKuva(ObjektinKuva,UusiHeittoKuvanPolku);

  TImage(KuvaLista.Items[Index]).Picture := ObjektinKuva;

  ObjektinKuva.Free;

  UusiHeitto.Checked := true; // valittu
  Siirtyma.Checked := false;
  Kysymys.Checked := false;

  // pelilautaan tuli muutos
  OnkoPelilautaaMuutettu := true;
end;

procedure TFormPelilaudanTeko.SiirtymaClick(Sender: TObject);
var
  Index: Integer;
  ObjektinKuva: TPicture;
begin
  if Siirtyma.Checked then exit; // jos siirtym on jo valittu, lhdetn pois!

  // saadaan tieto siit, mit kuvaa klikattiin hiirell
  Index := KuvaLista.IndexOf(TObject(PopupMenu.PopupComponent));
  TPelilaudanObjekti(ObjektiLista.Items[Index]).Tyyppi := ttSiirtyma;

  ObjektinKuva := TPicture.Create;
  LataaKuva(ObjektinKuva,SiirtymaKuvanPolku);

  TImage(KuvaLista.Items[Index]).Picture := ObjektinKuva;

  ObjektinKuva.Free;

  UusiHeitto.Checked := false;
  Siirtyma.Checked := true; // valittu
  Kysymys.Checked := false;

  // pelilautaan tuli muutos
  OnkoPelilautaaMuutettu := true;
end;

procedure TFormPelilaudanTeko.KysymysClick(Sender: TObject);
var
  Index: Integer;
  ObjektinKuva: TPicture;
begin
  if Kysymys.Checked then exit; // jos kysymys on jo valittu. lhdetn pois!

  // saadaan tieto siit, mit kuvaa klikattiin hiirell
  Index := KuvaLista.IndexOf(TObject(PopupMenu.PopupComponent));
  TPelilaudanObjekti(ObjektiLista.Items[Index]).Tyyppi := ttKysymys;

  ObjektinKuva := TPicture.Create;
  LataaKuva(ObjektinKuva,KysymysKuvanPolku);

  TImage(KuvaLista.Items[Index]).Picture := ObjektinKuva;

  ObjektinKuva.Free;

  UusiHeitto.Checked := false;
  Siirtyma.Checked := false;
  Kysymys.Checked := true; // valittu

  // pelilautaan tuli muutos
  OnkoPelilautaaMuutettu := true;

  //PaivitaAlkuJaLoppu
end;

procedure TFormPelilaudanTeko.MenuUusiClick(Sender: TObject);
begin
  if ( OnkoPelilautaaMuutettu ) then begin
    if ( MessageDlg('Nykyiseen pelilautaan tehtyj muutoksia ei ole viel tallennettu. Haluatko varmasti luoda uuden pelilaudan?', mtWarning, [mbYes, mbNo], 0) = mrNo ) then begin
      exit;
    end;
  end;

  // tyhjennetn edellinen pelilauta
  TyhjennaPelilauta();
  Kysymyssarja := '';
  LabelKysymyssarjanSijainti.Caption:=Kysymyssarja;

  // taustakuvaksi oletustaustakuva
  PaivitaTausta(OletusTaustakuva);
end;

procedure TFormPelilaudanTeko.MenuLataaPelilautaClick(Sender: TObject);
var
  IniFile: TIniFile;
  Tyyppi: String;
  i: Integer;
  X,Y: Integer;
  Objekti: String;
  UusiObjekti: TPelilaudanObjekti;
  ObjektinKuva: TPicture;
  KuvaKomponentti: TImage;
  ObjektienLkm: Integer;
  Polku,nimi,paate : string;

begin
  // Avataan oletuksena kansio, josta ohjelma suoritetaan
  OpenDialogLataaPelilauta.InitialDir := ExtractFilePath(application.ExeName);

  // Jos pelilautaan tehtyj muutoksia ei ole viel tallennettu, kysytn varmistus
  if OpenDialogLataaPelilauta.Execute then begin
    if ( OnkoPelilautaaMuutettu ) then begin
      if ( MessageDlg('Nykyiseen pelilautaan tehtyj muutoksia ei ole viel tallennettu. Haluatko varmasti ladata uuden pelilaudan?', mtWarning, [mbYes, mbNo], 0) = mrNo ) then begin
        exit;
      end;
    end;

    // tyhjennetn edellinen pelilauta
    TyhjennaPelilauta();

    // luodaan ini-tiedosto
    IniFile := TInifile.Create(OpenDialogLataaPelilauta.FileName);

    // otetaan pelilaudan nimi talteen
    PelilaudanNimi := OpenDialogLataaPelilauta.FileName;

    ErotaPolkuNimiJaPaate(PelilaudanNimi,Polku,Nimi,Paate);
    try
      // Luetaan kysymyssarjan polku
      Kysymyssarja := IniFile.ReadString('Kysymyssarja', 'Polku', '');
      // Kysymyssarjan polku absoluuttiseksi
      if Kysymyssarja <> '' then Kysymyssarja:=Polku+Kysymyssarja;
      LabelKysymyssarjanSijainti.Caption:=Kysymyssarja;

      // Luetaan taustakuvan polku
      // Jos taustakuvaa ei ole mritetty, ladataan oletustaustakuva
      TaustakuvanPolku := IniFile.ReadString('Taustakuva', 'Polku', OletusTaustakuva);
      if TaustakuvanPolku <> OletusTaustakuva then
        TaustakuvanPolku:=Polku+TaustakuvanPolku; //Muokataan polku absoluuttiseksi, ett ladataan aina oikeasta paikasta

      // Luetaan objektien lukumr
      ObjektienLkm := IniFile.ReadInteger('Objektit', 'Lkm', 0);

      for i:=0 to ObjektienLkm-1 do begin

        // Pivitetn objekteihin ilmaisevaa kohtaa ini-tiedostossa
        Objekti := 'Objekti ' + intToStr(i+1);

        // Luetaan ini-tiedostosta objektin arvot
        Tyyppi := IniFile.ReadString( Objekti, 'Tyyppi', '' );
        X := IniFile.ReadInteger( Objekti, 'X', 0 );
        Y := IniFile.ReadInteger( Objekti, 'Y', 0 );

        UusiObjekti := TPelilaudanObjekti.Create;
        ObjektinKuva := TPicture.Create;

        // Jos objekti on "Uusi heitto"
        if ( Tyyppi = 'UusiHeitto' ) then begin
          UusiObjekti.Tyyppi := ttUusiHeitto;
          LataaKuva(ObjektinKuva,UusiHeittoKuvanPolku);
        end

        // Jos objekti on "Siirtym"
        else if ( Tyyppi = 'Siirtyma' ) then begin
          UusiObjekti.Tyyppi := ttSiirtyma;
          LataaKuva(ObjektinKuva,SiirtymaKuvanPolku);
        end

        // Jos objekti on "Kysymys"
        else if ( Tyyppi = 'Kysymys' ) then begin
          UusiObjekti.Tyyppi := ttKysymys;
          LataaKuva(ObjektinKuva,KysymysKuvanPolku);
        end;

        // Luodaan KuvaKomponentti PanelPelilaudalle
        KuvaKomponentti := TImage.Create(PanelPelilauta);

        // Asetaan kuvan keskikohta hiiren osoittamaan paikkaan
        UusiObjekti.Koordinaatit := Point(X,Y);

        // Listn objekti objektilistaan
        ObjektiLista.Add(UusiObjekti);

        // Kuvakomponentin paikka

        KuvaKomponentti.Top := UusiObjekti.Koordinaatit.Y;
        KuvaKomponentti.Left := UusiObjekti.Koordinaatit.X;

        // Kuvakomponentin leveys ja korkeus
        KuvaKomponentti.Width := ObjektinKuva.Width;
        KuvaKomponentti.Height := ObjektinKuva.Height;

        // Asetetaan ruudun kuva kuvakomponenttiin
        KuvaKomponentti.Picture := ObjektinKuva;

        // Kuvan raahaamista varten
        KuvaKomponentti.DragMode := dmAutomatic;

        KuvaLista.Add(KuvaKomponentti);

        // Asetetaan tarvittavat attribuutit
        KuvaKomponentti.Parent := PanelPelilauta;
        KuvaKomponentti.Transparent := true;
        KuvaKomponentti.PopupMenu := PopupMenu;

// Piirretn viiva listyn ja edellisen ruudun vliin, jos edellinen ruutu on olemassa.
// ------------------------------------------------------------------------------
{
        if ( ObjektiLista.Count = 1 ) then begin
          // ainoastaan yksi objekti pelilaudalla
          // koordinaatit menevt nin tll kertaa, hieman sekavaa..
          // jos j aikaa, tmn voisi yritt korjata selkemmksi
          Taustakuva.Canvas.MoveTo(X + (ObjektinKuva.Width div 2),Y + (ObjektinKuva.Height div 2));
        end
        else begin
          // useita objekteja, yhdistetn ne viivoilla
          // koordinaatit menevt nin tll kertaa, hieman sekavaa..
          // jos j aikaa, tmn voisi yritt korjata selkemmksi
          Taustakuva.Canvas.LineTo(X + (ObjektinKuva.Width div 2),Y + (ObjektinKuva.Height div 2));
        end;
}
//------------------------------------------------------------------------------

        ObjektinKuva.Free; // vapautetaan ObjektinKuva
      end;
    finally
      IniFile.Free;
    end;

    // Pivitetn taustakuva ja objektien vliset viivat
    PaivitaTausta(TaustakuvanPolku);
    PaivitaViivat();
  end;
end;

procedure TFormPelilaudanTeko.MenuTallennaClick(Sender: TObject);
var
  IniFile: TIniFile;
  Objekti: String;
  i: Integer;
  PelilaudanObjekti: TPelilaudanObjekti;
  Polku, nimi, paate : string;
  KysPolku, KysNimi, KysPaate : string;

// Aliohjelma kopioi halutut tiedostot paikasta toiseen
procedure FileCopy(const PathName, FileName, Destination : string);
var Rec  : TSearchRec;
    Path, Dest : string;
begin
Path := IncludeTrailingBackslash(PathName);
Dest := IncludeTrailingBackslash(Destination);
if FindFirst (Path + FileName,
              faAnyFile - faDirectory,
              Rec) = 0 then
 try
   repeat
     CopyFile(PAnsiChar(Path + Rec.Name),PansiChar(Dest + Rec.Name),false);
   until FindNext(Rec) <> 0;
 finally
   FindClose(Rec);
 end;
end;


begin
  if PelilaudanNimi = '' then MenuTallennaNimellaClick(Sender)
  else begin

    // Jos vanha tiedosto on olemassa, poistetaan se
    if FileExists(PelilaudanNimi) then begin
      DeleteFile(PelilaudanNimi);
    end;

    // Luodaan saman niminen kansio kuin pelilauta on
    ErotaPolkuNimiJaPaate(PelilaudanNimi,polku,nimi,paate);
    if not DirectoryExists(Polku + Nimi) then
      if not CreateDir(Polku + Nimi) then begin
        MessageDlg('VIRHE TALLENNUKSESSA: ei voida luoda kansiota "' + Polku + Nimi + '"! Varmista, ett sinulla on kirjoitusoikeudet hakemistoon "' + Polku + '".',mtError	,[mbOK],0);
        exit;
      end;

    // Tallennetaan pelilaudan taustakuva sken luotuun hakemistoon ja
    // pivitetn taustakuvan ilmoittaman polun sijainti.
    // (pelkki bmp:it tallentuu, ja aina samalla nimellkin)
    TaustaBitmap.SaveToFile(Polku + Nimi + '\' + TaustakuvanVakioNimi); 
    TaustakuvanPolku:={Polku + }Nimi + '\' + TaustakuvanVakioNimi;

    if Kysymyssarja <> '' then begin
      // Kopioidaan kysymyssarja ja siihen liittyvt mediat pelilaudan alaisuuteen
      ErotaPolkuNimiJaPaate(Kysymyssarja,KysPolku,KysNimi,KysPaate);
      if not DirectoryExists(Polku + Nimi + '\' + KysNimi) then
        if not CreateDir(Polku + Nimi + '\' + KysNimi) then begin
          MessageDlg('VIRHE TALLENNUKSESSA: ei voida luoda kansiota "' + Polku + Nimi + '\' + KysNimi + '"! Varmista, ett sinulla on kirjoitusoikeudet hakemistoon "' + Polku + Nimi + '".',mtError	,[mbOK],0);
          exit;
        end;
      // ** Onko tss vaarana, ett kopioidaan itsens plle?
      CopyFile(PAnsiChar(KysPolku+KysNimi+KysPaate),PansiChar(Polku+Nimi+'\'+Kysnimi+Kyspaate),false);
      FileCopy(KysPolku + KysNimi,'*.*', Polku + Nimi + '\' + KysNimi);
      Kysymyssarja:=Nimi+'\'+KysNimi+KysPaate;
      LabelKysymyssarjanSijainti.Caption:=Polku+Kysymyssarja;
    end;

    // Aletaan tallentamaan varsinaista tekstitietoa ini-tiedostoon
    IniFile := TInifile.Create(PelilaudanNimi);
    try
      IniFile.WriteString('Kysymyssarja', 'Polku', Kysymyssarja);
      IniFile.WriteString('Taustakuva', 'Polku', TaustakuvanPolku);

      for i:=0 to ObjektiLista.Count-1 do begin

        // Pidetn kirjaa objektien lukumrst
        IniFile.WriteInteger('Objektit', 'Lkm', i+1);

        //IniFile.WriteInteger('Taustakuva', 'Asettelu', ???);

        // Pivitetn objekteihin ilmaisevaa kohtaa ini-tiedostossa
        Objekti := 'Objekti ' + intToStr(i+1);

        if ( TPelilaudanObjekti(ObjektiLista.Items[i]).Tyyppi = ttUusiHeitto ) then begin
          PelilaudanObjekti := TPelilaudanObjekti(ObjektiLista.Items[i]);
          // Aluksi kirjoitetaan kysymyksen tyyppi
          IniFile.WriteString(Objekti, 'Tyyppi', 'UusiHeitto');
          IniFile.WriteInteger(Objekti, 'X', PelilaudanObjekti.Koordinaatit.X);
          IniFile.WriteInteger(Objekti, 'Y', PelilaudanObjekti.Koordinaatit.Y);
        end

        else if ( TPelilaudanObjekti(ObjektiLista.Items[i]).Tyyppi = ttSiirtyma ) then begin
          PelilaudanObjekti := TPelilaudanObjekti(ObjektiLista.Items[i]);
          // Aluksi kirjoitetaan kysymyksen tyyppi
          IniFile.WriteString(Objekti, 'Tyyppi', 'Siirtyma');
          IniFile.WriteInteger(Objekti, 'X', PelilaudanObjekti.Koordinaatit.X);
          IniFile.WriteInteger(Objekti, 'Y', PelilaudanObjekti.Koordinaatit.Y);
        end

        else if ( TPelilaudanObjekti(ObjektiLista.Items[i]).Tyyppi = ttKysymys ) then begin
          PelilaudanObjekti := TPelilaudanObjekti(ObjektiLista.Items[i]);
          // Aluksi kirjoitetaan kysymyksen tyyppi
          IniFile.WriteString(Objekti, 'Tyyppi', 'Kysymys');
          IniFile.WriteInteger(Objekti, 'X', PelilaudanObjekti.Koordinaatit.X);
          IniFile.WriteInteger(Objekti, 'Y', PelilaudanObjekti.Koordinaatit.Y);
        end;

      end;

    finally
      IniFile.Free;
    end;

    // Tiedosto tallennettu, eik muutoksia tehty sen jlkeen
    OnkoPelilautaaMuutettu := false;
  end;
end;

procedure TFormPelilaudanTeko.MenuLopetaClick(Sender: TObject);
begin
  Close;
end;

procedure TFormPelilaudanTeko.MenuLiitaKysymyssarjaClick(Sender: TObject);
begin
  if OpenDialogLiitaKysymyssarja.Execute then begin

    if ( Kysymyssarja <> '' ) then begin
      if ( MessageDlg('Pelilaudalle on asetettu jo kysymyssarja "' + Kysymyssarja + '". Haluatko korvata tmn kysymyssarjan?', mtWarning, [mbYes, mbNo], 0) = mrNo ) then begin
        exit;
      end;
    end;

    Kysymyssarja := OpenDialogLiitaKysymyssarja.FileName;
    LabelKysymyssarjanSijainti.Caption:=Kysymyssarja;
    OnkoPelilautaaMuutettu:=true;
  end;
end;

procedure TFormPelilaudanTeko.MenuTallennaNimellaClick(Sender: TObject);
begin
  // Avataan oletuksena kansio, josta ohjelma suoritetaan
  SaveDialogTallennaPelilauta.InitialDir := ExtractFilePath(application.ExeName);

  if SaveDialogTallennaPelilauta.Execute then begin
    PelilaudanNimi := SaveDialogTallennaPelilauta.FileName;

    if ( AnsiRightStr(PelilaudanNimi,4) <> '.pla' ) then begin
      Insert('.pla', PelilaudanNimi, Length(PelilaudanNimi)+1);
    end;

    // Jos vanha tiedosto on jo olemassa
    if ( FileExists(PelilaudanNimi) ) then begin
      if ( MessageDlg('Pelilauta "' + PelilaudanNimi + '" on jo olemassa. Haluatko korvata tmn pelilaudan?', mtWarning, [mbYes, mbNo], 0) = mrNo ) then begin
        exit;
      end;
    end;

    MenuTallennaClick(Sender);
  end;
end;

procedure TFormPelilaudanTeko.TyhjennaPelilauta;
begin
  ObjektiLista.Clear;
  KuvaLista.Clear;
  PaivitaViivat;
  OnkoPelilautaaMuutettu := false;
  PelilaudanNimi := ''; // Pelilaudalle ei ole annettu viel nime
  Kysymyssarja := '';
  LabelKysymyssarjanSijainti.Caption:=Kysymyssarja;
end;

procedure TFormPelilaudanTeko.FormClose(Sender: TObject; var Action: TCloseAction);
var
  Arvo: Integer;
begin
  // Jos on asetettu objekteja pelilaudalle eik sille ole asetettu kysymyssarjaa
  if ( ( ObjektiLista.Count > 0 ) and ( Kysymyssarja = '' ) ) then begin
    if ( MessageDlg('Pelilautaan ei ole liitetty viel kysymyssarjaa. Haluatko liitt kysymyssarjan?', mtWarning, [mbYes, mbNo], 0) = mrYes ) then
      MenuLiitaKysymyssarjaClick(Sender);
  end;

  // Jos ohjelmaa ollaan lopettamassa eik muutoksia ole tallennettu, kysytn vahvistus
  if ( OnkoPelilautaaMuutettu ) then begin
    Arvo := MessageDlg('Haluatko tallentaa pelilaudan?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    if ( Arvo = mrNo ) then
      Action := caFree
    else if ( Arvo = mrYes ) then begin
      MenuTallennaClick(Sender);
      // jos kyttj ei tallentanut, ei poistuta ohjelmasta
      if ( OnkoPelilautaaMuutettu ) then Action := caNone;
    end
    else if ( Arvo = mrCancel ) then
      Action := caNone;
  end;
end;

procedure TFormPelilaudanTeko.PaivitaTausta(TaustanPolku: String);
var
  Tausta: TPicture;
begin
  // jos polku on tyhj, lhdetn pois!
  if TaustanPolku = '' then begin
    exit;
  end;

  Tausta := TPicture.Create;
  LataaKuva(Tausta,TaustanPolku);

  TaustaBitmap := Tausta.Bitmap;

  Taustakuva.Top := 0;
  //Taustakuva.Width := 0;
  Taustakuva.Left:=0;
  Taustakuva.Picture := Tausta;

  Taustakuva.Width:=Taustakuva.Picture.Width;
  Taustakuva.Height:=Taustakuva.Picture.Height;

  SovitaPanelToiminnot;

end;

procedure TFormPelilaudanTeko.AsetaTaustakuva(Asettelu: TTaustanAsettelu);
begin
  // oikea asettelu plle
  TaustanAsettelu := Asettelu;
end;

procedure TFormPelilaudanTeko.PanelVihjeResize(Sender: TObject);
begin
  PanelVihje.Realign; // Ksketn alustapaneelin tytt tilansa
  // Vihje oikean kokoiseksi
  LabelVihje.Width := PanelVihje.Width;
  LabelVihje.Height := PanelVihje.Height;
  LabelVihje.Refresh;
end;

procedure TFormPelilaudanTeko.ErotaPolkuNimiJaPaate(s: String; var Polku,
  Nimi, Paate: String);
var
  IndexNimi: Integer;
  IndexPaate: Integer;
begin
  IndexNimi := LastDelimiter('/\', s);
  IndexPaate := LastDelimiter('.', s);

  // Jos kyttj ei kirjoita nimelleen ptett, listn
  // se itse. Tm siksi, koska halutaan vltt
  if IndexPaate <= 0 then
    IndexPaate:=Length(s) + 1; // +1 johtunee "pisteest tiedoston ptteess"

  // Otetaan talteen polku ilman tiedoston nime
  Polku := Copy(s, 1, IndexNimi);

  // Otetaan talteen tiedoston nimi polusta
  Nimi := Copy(s, IndexNimi+1, ((Length(s)-IndexNimi) - (Length(s)-IndexPaate+1)));

  // Otetaan talteen tiedoston pte polusta
  Paate := Copy(s, IndexPaate, Length(s)-IndexNimi)
end;


procedure TFormPelilaudanTeko.SovitaPanelToiminnot;
begin
  // Sovittaa panelToiminnot paneelin korkeuden taustakuvan korkuiseksi
  // ett formi saisi itselleen uuden koon. (Ettei yksi liian korkea
  // komponentti pysyt sen kutistumista.)
  PanelToiminnot.Align:=alNone;
  PanelToiminnot.Height:=Taustakuva.Height;
  PanelToiminnot.Align:=alLeft;
end;

procedure TFormPelilaudanTeko.BitBtnUusiClick(Sender: TObject);
begin
  MenuUusiClick(Sender);
end;

procedure TFormPelilaudanTeko.BitBtnAvaaClick(Sender: TObject);
begin
  MenuLataaPelilautaClick(Sender);
end;

procedure TFormPelilaudanTeko.BitBtnTallennaClick(Sender: TObject);
begin
  MenuTallennaClick(Sender);
end;

procedure TFormPelilaudanTeko.PanelTyokalupalkkiCanResize(Sender: TObject;
  var NewWidth, NewHeight: Integer; var Resize: Boolean);
begin
  NewWidth:=Taustakuva.Picture.Width+136; // Hihavakio on sivutykalujen koko
                                          // vhennettyn yhdell. Tllin
                                          // palkki ei ole tysin kiinni
                                          // reunassa. Jos se olisi kiinni, niin
                                          // jostakin syyst sit ei saa en
                                          // jrkevsti pienennetty... :-Z
  resize:=true;
end;

procedure TFormPelilaudanTeko.BitBtnPoistaRuudutClick(Sender: TObject);
begin
  if ( MessageDlg('Haluatko varmasti poistaa kaikki pelilaudan ruudut?', mtWarning, [mbYes, mbNo], 0) = mrNo ) then begin
    exit;
  end;
  // Tyhjennetn kaikki ruudut
  ObjektiLista.Clear;
  KuvaLista.Clear;
  PaivitaViivat;
end;

end.
