// Formi ilmoittamaan pelivuoron vaihtumisen Talariuksessa.
//
// Tekij:
//   Heikki Nevala
//
// Luotu: 15.2.2006
// Muokattu: 15.2.2006

unit VuoroVaihtuuForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TFormVuoroVaihtuu = class(TForm)
    ButtonOK: TButton;
    LabelOtsikko: TLabel;
    ImagePelaaja: TImage;
    LabelNimi: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
  end;

var
  FormVuoroVaihtuu: TFormVuoroVaihtuu;

procedure NaytaVuoroVaihtuu(ilmoitus:string; kuva:TBitmap; nimi:string);

implementation

{$R *.dfm}

{ TFormVuoroVaihtuu }

// Aliohjelma hoitaa formin nyttmisen, purkaa sille tarvittavat tiedot jne.
procedure NaytaVuoroVaihtuu(ilmoitus: string; kuva: TBitmap; nimi: string);
var
  f : TFormVuoroVaihtuu;


begin
  f:=TFormVuoroVaihtuu.Create(nil);
  // Pelaajan kuva paikalleen, vaatii hieman kikkailua, ett saadaan
  // nkymn oikein...
  f.ImagePelaaja.Picture.Bitmap:=kuva;
  f.ImagePelaaja.Width:=f.ImagePelaaja.Picture.Bitmap.Width;
  f.ImagePelaaja.Height:=f.ImagePelaaja.Picture.Bitmap.Height;
  f.ImagePelaaja.Canvas.Draw(0,0,kuva);
  f.ImagePelaaja.Left:=(f.ClientWidth div 2)-(f.ImagePelaaja.Width div 2);
  // Ilmoitus paikoilleen
  f.LabelOtsikko.Caption:=ilmoitus;
  f.LabelOtsikko.Left:=(f.ClientWidth div 2)-(f.LabelOtsikko.Width div 2);
  // Pelaajan nimi paikalleen ja oikeaan kohtaan
  f.LabelNimi.Caption:=nimi;
  f.LabelNimi.Left:=(f.ClientWidth div 2)-(f.LabelNimi.Width div 2);
  f.ShowModal;
  f.Free;
end;

procedure TFormVuoroVaihtuu.FormCreate(Sender: TObject);
begin
  // Synnytetn formi keskelle ruutua
  Left := (Screen.Width div 2) - (Width div 2);
  Top := (Screen.Height div 2) - (Height div 2);
  ButtonOK.Left:=(ClientWidth div 2)-(ButtonOK.Width div 2)
end;

end.
