// Unit sislt erilaisten medioiden lataamisessa kytettvi aliohjelmia.

unit MedioidenLataajat;

interface

uses MPlayer, Graphics, Dialogs, Classes,JPEG;

    procedure LataaKuva(var Kuva: TPicture; Polku: String); overload;
    procedure LataaKuva(var Kuva: TBitmap; Polku: String); overload;
    procedure LataaMedia(var Media: TMediaPlayer; Polku: String);

implementation

procedure LataaKuva(var Kuva: TPicture; Polku: String);
begin
  //if Polku = '' then exit;
  try
    Kuva.LoadFromFile(Polku);
  except
    on EInvalidGraphic do
      MessageDlg('Kuvatiedosto ' + Polku + ' on virheellinen!', mtError, [mbOK], 0);
    on EFOpenError do
      MessageDlg('Kuvatiedostoa ' + Polku + ' ei lydy!', mtError, [mbOK], 0);
  end;
end;

procedure LataaKuva(var Kuva: TBitmap; Polku: String);
begin
  try
    Kuva.LoadFromFile(Polku);
  except
    on EInvalidGraphic do
      MessageDlg('Kuvatiedosto ' + Polku + ' on virheellinen!', mtError, [mbOK], 0);
    on EFOpenError do
      MessageDlg('Kuvatiedostoa ' + Polku + ' ei lydy!', mtError, [mbOK], 0);
  end;
end;

procedure LataaMedia(var Media: TMediaPlayer; Polku: String);
begin
  Media.Filename := Polku;
  try
	  Media.Open;
		Media.Play;
  except
	  on EMCIDeviceError do
      MessageDlg('Mediatiedostoa ' + Polku + ' ei lydy!', mtError, [mbOK], 0);
	end;
end;

end.
