{
ALEA PROJEKTI
Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)
viimeksi muokattu: 23.5.2006

TFormOdotushuone nytt peliin liittyneet asiakkaa ja pelin tiedot.
Vasemmalla: Peliin liittyneet asiakkaat ja heidn pelinappulansa. Poistonapit ja
pelin aloittamisnappi vain pelin luojalla.
Oikealla: Pelin tiedot.
Aloita peli -nappi kynnist pelin kaikille asiakkaille. Peruuta pelinluojalla
sulkee odotushuoneen kaikilta asiakkailta palauttaen heidt TFormMetaOppilaanLiittma:an
Peruuta nappi muuttuu Poistu napiksi asiakkaille ja sulkee odotushuoneen siirten
heidt TFormMetaOppilaanLiittyma:an. Jos peli ei ollut verkossa, palataan
TFormVerkkovalinta:an.
}
unit OdotushuoneForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, md5, Contnrs, Objekti, Pelilogiikka,
  ScktComp, Paketit, ChatIkkuna;

type
  TFormOdotushuone = class(TForm)
    GroupBoxPelinTiedot: TGroupBox;
    LabelNimi: TLabel;
    LabelPelilauta: TLabel;
    LabelAihealue: TLabel;
    ListBoxKysymyssarjat: TListBox;
    LabelVaikeustaso: TLabel;
    LabelKysymyssarjat: TLabel;
    //kaikki pelaajat
    GroupBoxPelaajat: TGroupBox;
    //pelaaja 1 tiedot
    LabelPelaaja1Nimi: TLabel;
    GroupBoxPelaaja1: TGroupBox;
    LabelPelaaja1Nappula: TLabel;
    ImagePelaaja1Nappula: TImage;
    //pelaaja 2 tiedot
    GroupBoxPelaaja2: TGroupBox;
    LabelPelaaja2Nimi: TLabel;
    LabelPelaaja2Nappula: TLabel;
    ImagePelaaja2Nappula: TImage;
    ButtonPoistaPelaaja2: TButton;
    //pelaaja 3 tiedot
    GroupBoxPelaaja3: TGroupBox;
    LabelPelaaja3Nimi: TLabel;
    LabelPelaaja3Nappula: TLabel;
    ImagePelaaja3Nappula: TImage;
    ButtonPoistaPelaaja3: TButton;
    //pelaaja 4 tiedot
    GroupBoxPelaaja4: TGroupBox;
    LabelPelaaja4Nimi: TLabel;
    LabelPelaaja4Nappula: TLabel;
    ImagePelaaja4Nappula: TImage;
    ButtonPoistaPelaaja4: TButton;
    {pelaajan tiedot piilotetaan jos niin montaa pelaajaa ei ole.
    Esim. max 2 pelaajaa, GroupBoxPelaaja3 & 4 piilotetaan. }

    BitBtnPeruuta: TBitBtn;
    BitBtnAloitaPeli: TBitBtn;
    EditPelaaja1Nimi: TEdit;
    EditPelaaja2Nimi: TEdit;
    EditPelaaja3Nimi: TEdit;
    EditPelaaja4Nimi: TEdit;
    TimerPakollinenOdotus: TTimer;
    procedure EditPelaaja1NimiChange(Sender: TObject);
    procedure EditPelaaja2NimiChange(Sender: TObject);
    procedure EditPelaaja3NimiChange(Sender: TObject);
    procedure EditPelaaja4NimiChange(Sender: TObject);
    procedure BitBtnPeruutaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtnAloitaPeliClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure TimerPakollinenOdotusTimer(Sender: TObject);
    procedure ButtonPoistaPelaaja2Click(Sender: TObject);
    procedure ButtonPoistaPelaaja3Click(Sender: TObject);
    procedure ButtonPoistaPelaaja4Click(Sender: TObject);

  private
    Kysymyssarjat: TStringList;
    Luoja: THahmo;
    PelaajaLista: TObjectList;
    Pelilauta: String;
    Salasana: MD5Digest;
    KaytaSalasanaa: Boolean;
    MaxPelaajia: Integer;
    Pelaajia: Integer;
    PyydaArvosanaa: Boolean;
    Palvelin: Boolean;
    PelinNimi: String;
    Verkossa: Boolean;
    ClientSocketPeli: TClientSocket;
    Meta: TClientSocket;
    OmaNimi: String;
    OmaTunnus: String;
    PelinHakemisto: String;
    ChatIkkuna: TFormChat;
    AlustusKesken: Boolean; //jos alustus on kesken, ei saa pivitell listoja.
    ImageSuru: TImage;
    procedure EditPelaajaXNimiChange(Sender: TEdit; Pelaaja: Integer);
    procedure TaytaOffline;
    procedure LaitaKuvatJaNimet;
    procedure AnnaPaketti(Socket: TCustomWinSocket);
    procedure ClientSocketPeliRead(Sender: TObject;
      Socket: TCustomWinSocket);

    procedure LiittyyPeliin(Paketti: TLiittyiPeliin);
    procedure Siivoa;
    procedure Laheta(Paketti: TPaketti; Socket: TCustomWinSocket);
    procedure OdotaHetki;


  public
    Tulos: Boolean; //korvaa modal resultin
    Sulje: Boolean; //Tosi jos saa sulkea
    procedure AsetaChat(Chat: TFormChat);
    procedure Kasittelija(Paketti: TPaketti);
    procedure PoistuuPelista(PoistuvaPelaaja: TPoistui);
    procedure AsetaMetaSocket(Meta: TClientSocket);

    function AnnaPelaajalista: TObjectList;
    function AnnaPelaajienMaara: Integer;
    procedure AnnaHakemisto(PelinHakemisto: String);
    procedure AsetaSuru(Suru: TImage);

    //katso kommentti toteutuksesta
    procedure Alusta(Kysymyssarjat: TStringList; PelinNimi: String;
      Pelilauta: String; PelaajienMaara: Integer;
      KaytaSalasanaa, PyydaArvosanaa: Boolean; Palvelin,
      Verkossa: Boolean; ClientSocketPeli: TClientSocket; PelaajaLista: TObjectList);
    procedure LaitaOmatTiedot(OmaNimi: String; OmaTunnus: String);
  end;

const MaxPelaajia = 4;
const PelaajaKuvat: array[0..(MaxPelaajia-1)] of String = ('kuvat\pelaaja1.bmp',
  'kuvat\pelaaja2.bmp', 'kuvat\pelaaja3.bmp', 'kuvat\pelaaja4.bmp');

implementation

uses LuoPeliForm, MedioidenLataajat, PelinPelaaminenPaaForm, IlmoitusForm;

{$R *.dfm}

{Alustetaan odotushuone.
Kysymyssarjat: Peliin tulevat kysymyssarjat (nimet ilman ptett ja polkua)
PelinNimi: Pelille asetettu nimi
Pelilauta: Peliss kytettv lauta (nimi ilman ptett ja polkua)
PelaajienMaara: Pelin maksimipelaajamr
KaytaSalasaa: Kytetnk peliss salasanaa
PyydaArvosanaa: Kysytnk pelaajilta arvosanaa pelin ptytty
Palvelin: Onko tm _palvelimen_ odotushuone (voi potkia vke ja aloittaa pelin)
Verkossa: Onko tm peli verkossa vai ei
ClientSocketPeli: Yhteys pelilogiikkaan
PelaajaLista: Peliss olevat pelaajat (THahmo)}
procedure TFormOdotushuone.Alusta(Kysymyssarjat: TStringList; PelinNimi: String;
  Pelilauta: String; PelaajienMaara: Integer; KaytaSalasanaa,
  PyydaArvosanaa: Boolean; Palvelin, Verkossa: Boolean;
  ClientSocketPeli: TClientSocket; PelaajaLista: TObjectList);
var I: Integer; Nimi, Polku, Paate: String; Hahmo: THahmo; Kuva: TBitmap;
begin
  AlustusKesken := True;
  Siivoa;
  Pelaajia := 0;
  Sulje := False;
  Self.Palvelin := Palvelin;
  Self.Kysymyssarjat.Free;
  Self.Kysymyssarjat := TStringList.Create;
  Self.Kysymyssarjat.AddStrings(Kysymyssarjat);

  LabelPelilauta.Caption := 'Pelilauta: ' + Pelilauta;
  Self.Pelilauta := Pelilauta;
  Self.PelinNimi := PelinNimi;
  Self.Salasana := Salasana;
  Self.MaxPelaajia := PelaajienMaara;
  Self.KaytaSalasanaa := KaytaSalasanaa;
  Self.PyydaArvosanaa := PyydaArvosanaa;
  Self.Verkossa := Verkossa;
  for I:=0 to Self.Kysymyssarjat.Count-1 do begin
      ListBoxKysymyssarjat.Items.Add(Self.Kysymyssarjat[I]);
  end;
  LabelNimi.Caption := 'Pelin nimi: ' + PelinNimi;
  LabelPelilauta.Caption := 'Pelilauta: ' + Pelilauta;
  LabelAihealue.Caption := 'Aihealue: ' + 'mrittelemtn';
  LabelVaikeustaso.Caption := 'Vaikeustaso: ' + 'mrittelemtn';

  //nytetn maksimipelaajamrn mukainen joukko pelaajia
  GroupBoxPelaaja4.Visible := False;
  GroupBoxPelaaja3.Visible := False;
  GroupBoxPelaaja2.Visible := False;

  if (PelaajienMaara > 1) then begin
    GroupBoxPelaaja2.Visible := True;
    if (PelaajienMaara > 2) then begin
      GroupBoxPelaaja3.Visible := True;
      if (PelaajienMaara > 3) then begin
        GroupBoxPelaaja4.Visible := True;
      end;
    end;
  end;

  //painikkeet kuntoon
  if not Palvelin then begin
    BitBtnAloitaPeli.Hide;
    BitBtnPeruuta.Caption := 'Poistu';
  end
  else
  begin
    BitBtnAloitaPeli.Show;
    BitBtnPeruuta.Caption := 'Peruuta';
  end;

  //varmistetaan pelaajalistan olemassaolo
  Self.PelaajaLista.Free;
  Self.PelaajaLista := TObjectList.Create();

  //verkkopeliss listn peliss olevat pelaajat listaan
  if Verkossa then begin
    Pelaajia := PelaajaLista.Count;
    for I := 0 to PelaajaLista.Count-1 do
    begin
      Hahmo := THahmo.Create;
      Hahmo.Nimi := (PelaajaLista[I] as THahmo).Nimi;
      Hahmo.Tunnus := (PelaajaLista[I] as THahmo).Tunnus;
      Self.PelaajaLista.Add(Hahmo);
    end;
  end;

  //offline peliss listn offline pelaajat ja annetaan kirjoitusoikeudet
  if not Verkossa then
  begin
    Pelaajia := MaxPelaajia;
    TaytaOffline;
    EditPelaaja1Nimi.ReadOnly := False;
    EditPelaaja2Nimi.ReadOnly := False;
    EditPelaaja3Nimi.ReadOnly := False;
    EditPelaaja4Nimi.ReadOnly := False;
  end;

  //mikli ei olla verkossa eik palvelin ei potkita vke
  if not Verkossa or not Palvelin then
  begin
    ButtonPoistaPelaaja2.Hide;
    ButtonPoistaPelaaja3.Hide;
    ButtonPoistaPelaaja4.Hide;
  end
  else
  begin
    ButtonPoistaPelaaja2.Show;
    ButtonPoistaPelaaja3.Show;
    ButtonPoistaPelaaja4.Show;
  end;

  Self.ClientSocketPeli := ClientSocketPeli;
  Self.ClientSocketPeli.OnRead := ClientSocketPeliRead;

  AlustusKesken := False;
  //pivitetn tiedot ruutuun
  LaitaKuvatJaNimet;
end;

//ensimmisell kyttkerralla ladataan kuvat kyttn ja asetetaan pelin
//juurihakemisto
procedure TFormOdotushuone.AnnaHakemisto(PelinHakemisto: String);
begin
  if Self.PelinHakemisto = '' then
  try
    ImagePelaaja1Nappula.Picture.LoadFromFile(PelinHakemisto+PelaajaKuvat[0]);
    ImagePelaaja2Nappula.Picture.LoadFromFile(PelinHakemisto+PelaajaKuvat[1]);
    ImagePelaaja3Nappula.Picture.LoadFromFile(PelinHakemisto+PelaajaKuvat[2]);
    ImagePelaaja4Nappula.Picture.LoadFromFile(PelinHakemisto+PelaajaKuvat[3]);
  except
    ShowMessage('Kuvien lataamisessa tuli ongelma');
  end;
    Self.PelinHakemisto := PelinHakemisto;
end;

//siivoaa odotushuoneen alkutilaan
procedure TFormOdotushuone.Siivoa;
begin
  Self.ListBoxKysymyssarjat.Clear;
  if (Pelaajalista <> nil) then Self.PelaajaLista.Clear;
  Pelaajia := 0;
  LaitaKuvatJaNimet;
  GroupBoxPelaaja4.Visible := False;
  GroupBoxPelaaja3.Visible := False;
  GroupBoxPelaaja2.Visible := False;
  EditPelaaja2Nimi.Text := '< ei pelaajaa >';
  EditPelaaja3Nimi.Text := '< ei pelaajaa >';
  EditPelaaja4Nimi.Text := '< ei pelaajaa >';
  //  Self.Kysymyssarjat.Free;
end;

//lis offline pelaajat listaan ja pivitt nytn
procedure TFormOdotushuone.TaytaOffline;
var Tayte: THahmo; I: Integer;
begin
  for I:=0 to MaxPelaajia -1 do begin
    Tayte := THahmo.Create;
    Tayte.Nimi := '< nimetn >';
    Tayte.Tunnus := 'offline'+IntToStr(I);
    PelaajaLista.Add(Tayte);
  end;
  LaitaKuvatJaNimet;
end;

//pivitt nytn, eli asettaa pelaajien nimet ja kuvat paikoilleen. Lisksi
//poistonappien tila ja < ei pelaajaa > tekstit pivitetn.
procedure TFormOdotushuone.LaitaKuvatJaNimet;
begin

  ButtonPoistaPelaaja2.Enabled := False;
  ButtonPoistaPelaaja3.Enabled := False;
  ButtonPoistaPelaaja4.Enabled := False;

  if Verkossa then
  begin
    EditPelaaja2Nimi.Text := '< ei pelaajaa >';
    EditPelaaja3Nimi.Text := '< ei pelaajaa >';
    EditPelaaja4Nimi.Text := '< ei pelaajaa >';
  end;
  
  if Pelaajia > 0 then begin
    EditPelaaja1Nimi.Text := (PelaajaLista.Items[0] as THahmo).Nimi;
    if Pelaajia > 1 then begin
      EditPelaaja2Nimi.Text := (PelaajaLista.Items[1] as THahmo).Nimi;
      ButtonPoistaPelaaja2.Enabled := True;
      if Pelaajia > 2 then begin
        EditPelaaja3Nimi.Text := (PelaajaLista.Items[2] as THahmo).Nimi;
        ButtonPoistaPelaaja3.Enabled := True;
        if Pelaajia > 3 then begin
          EditPelaaja4Nimi.Text := (PelaajaLista.Items[3] as THahmo).Nimi;
          ButtonPoistaPelaaja4.Enabled := True;
        end;
      end;
    end;
  end;
end;

//palauttaa pelaajalistasta uuden kopion
function TFormOdotushuone.AnnaPelaajalista: TObjectList;
var I: Integer; Hahmo: THahmo;
begin
  Result := TObjectList.Create;
  for I := 0 to PelaajaLista.Count-1 do
  begin
    Hahmo := THahmo.Create;
    Hahmo.Nimi := (PelaajaLista[I] as THahmo).Nimi;
    Hahmo.Tunnus := (PelaajaLista[I] as THahmo).Tunnus;
    Hahmo.KuvanPolku := PelinHakemisto+PelaajaKuvat[I];
    Result.Add(Hahmo);
  end;
end;

//palauttaa pelaajien lukumrn
function TFormOdotushuone.AnnaPelaajienMaara: Integer;
begin
  Result := Pelaajia;
end;

//offlinepeliss nimenmuutoksen yhteydess pivitetn mys sisinen lista.
//(seuraavat 4 passaa tiedon muokkauksesta eteenpin)
procedure TFormOdotushuone.EditPelaajaXNimiChange(Sender: TEdit; Pelaaja: Integer);
begin
  if (not Verkossa) and (not AlustusKesken) then begin
    if (Sender is TEdit) then
      if not ((Sender as TEdit).Text = '') then
    (PelaajaLista.Items[Pelaaja] as THahmo).Nimi := Sender.Text;
  end;
end;

procedure TFormOdotushuone.EditPelaaja1NimiChange(Sender: TObject);
begin
  EditPelaajaXNimiChange(Sender as TEdit, 0);
end;

procedure TFormOdotushuone.EditPelaaja2NimiChange(Sender: TObject);
begin
  EditPelaajaXNimiChange(Sender as TEdit, 1);
end;

procedure TFormOdotushuone.EditPelaaja3NimiChange(Sender: TObject);
begin
  EditPelaajaXNimiChange(Sender as TEdit, 2);
end;

procedure TFormOdotushuone.EditPelaaja4NimiChange(Sender: TObject);
begin
  EditPelaajaXNimiChange(Sender as TEdit, 3);
end;

{
Uusi pelaaja on liittynyt peliin, joten listn se listoille ja pivitetn
nytt. Mys chatin lista pivitetn. Palvelin lhett metalle tiedon
pelaajan liittymisest.
}
procedure TFormOdotushuone.LiittyyPeliin(Paketti: TLiittyiPeliin);
var UusiPelaaja: THahmo;
begin
  OdotaHetki; //pidetn huoli ettei kukaan hakkaa nappeja satunnaisesti hetkeen.
  if not Verkossa then begin
    LaitaKuvatJaNimet;
    exit;
  end;
  UusiPelaaja := THahmo.Create;
  UusiPelaaja.Nimi := Paketti.PelaajanNimi;
  UusiPelaaja.Tunnus := Paketti.Tunnus;
  if (Pelaajia < MaxPelaajia) then begin
//    if not (PelaajaLista.Items[Pelaajia] = nil) then PelaajaLista.Items[Pelaajia].Free;
    PelaajaLista.Add(UusiPelaaja);
    Pelaajia := Pelaajia + 1;
    LaitaKuvatJaNimet;
  end;
  ChatIkkuna.Liittyi(Paketti.PelaajanNimi);
    if (Paketti.Tunnus <> OmaTunnus) then
      ChatIkkuna.Vastaanota('---'+Paketti.PelaajanNimi + ' on liittynyt peliin---');
  if Palvelin then Laheta(TLiittyiPeliin.Create(UusiPelaaja.Nimi, UusiPelaaja.Tunnus), Meta.Socket);
end;

//lhett paketin sockettiin
procedure TFormOdotushuone.Laheta(Paketti: TPaketti; Socket: TCustomWinSocket);
begin
  try
    Socket.SendText(Paketti.PalautaPaketti);
  finally
    FreeAndNil(Paketti);
  end;
end;

{
Pelaaja on poistunut odotushuoneesta. pivitetn listat ja laitetaan lisksi
viesti chattiin. Mikli asiakas saa tiedon omasta poistumisestaan,
on palvelin poistanut asiakkaan, joten nytetn ilmoitus, suljetaan yhteys ja
suljetaan formi, kuten tavallisesti poistuttaessa.
}
procedure TFormOdotushuone.PoistuuPelista(PoistuvaPelaaja: TPoistui);
var I: Integer; Poistuva: TObject;
begin
  OdotaHetki;
  if (PoistuvaPelaaja.Tunnus = OmaTunnus) then
  begin
//    ShowMessage('Sinut on poistettu pelist');
    NaytaIlmoitus('', 'Sinut on poistettu pelist', ImageSuru.Picture.Bitmap);
    BitBtnPeruuta.Click;
    ClientSocketPeli.Close;
  end;
  if (Pelaajia > 1) then
    for I := 0 to Pelaajia-1 do begin
      if (AnsiCompareStr((PelaajaLista.Items[I] as THahmo).Tunnus, PoistuvaPelaaja.Tunnus) = 0) then
      begin
        Poistuva := PelaajaLista.Items[I];
        PelaajaLista.Delete(I);
//        FreeAndNil(Poistuva); //kaataa?
        Pelaajia := Pelaajia - 1;
        LaitaKuvatJaNimet;
      end;
    end;
    ChatIkkuna.Poistui(PoistuvaPelaaja.PelaajanNimi);
    ChatIkkuna.Vastaanota('---'+PoistuvaPelaaja.PelaajanNimi + ' on poistunut pelist---');
end;

//otetaan surukuva talteen.
procedure TFormOdotushuone.AsetaSuru(Suru: TImage);
begin
  Self.ImageSuru := Suru;
end;

//Ksittelee paketin tai passaa sen oikealle ksittelijlle.
procedure TFormOdotushuone.Kasittelija(Paketti: TPaketti);
begin
  try
    if (Paketti = nil) then exit;
    case Paketti.PaketinTyyppi of
    LiittyiPeliinTyyppi:
      LiittyyPeliin(TLiittyiPeliin(Paketti));
    PoistuiTyyppi:
      PoistuuPelista(TPoistui(Paketti));
    PeliAlkaaTyyppi:
      BitBtnAloitaPeli.Click;
    PeliPaattyiTyyppi:
      BitBtnPeruuta.Click;
    end
  finally
    FreeAndNil(Paketti);
  end;
end;

//Passaa socketin paketin lukemiseen, kun paketteja on tullut
procedure TFormOdotushuone.ClientSocketPeliRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  AnnaPaketti(Socket);
end;

//Lukee sockettiin tulleet paketit. Muodostaa ja passaa ne ksittelille
procedure TFormOdotushuone.AnnaPaketti(Socket: TCustomWinSocket);
var PaketinTyyppi: Pakettityyppi;
    XMLPaketti: String;
    XMLPakettiLista: TStringList;
    I: Integer;
begin
  XMLPaketti := Socket.ReceiveText;
  if XMLPaketti = '' then begin
    exit;
  end;

  XMLPakettiLista := PilkoXML(XMLPaketti);
{  Uudet := PilkoXML(XMLPaketti);
  Uudet.AddStrings(XMLPakettiLista);
  XMLPakettiLista := Uudet; }

  for I := XMLPakettiLista.Count-1 downto 0 do
  begin
    XMLPaketti := XMLPakettiLista[I];
    PaketinTyyppi := PalautaPaketinTyyppi(XMLPaketti);
    case PaketinTyyppi of
      ChatViestiLahettajaltaTyyppi: FormPelinPelaaminen.KasitteleChat(TChatViestiLahettajalta.Create(XMLPaketti));
     { KirjauduTyyppi: Result := TKirjaudu.Create(PakettiTaulu, PaketinKoko);
      KirjautunutTyyppi: Result := TKirjautunut.Create(PakettiTaulu, PaketinKoko);
      PelienMaaraTyyppi: Result := TPelienMaara.Create(PakettiTaulu, PaketinKoko);
      PelilistaTyyppi: Result := TPelilista.Create(PakettiTaulu, PaketinKoko);
      UusiPeliTyyppi: Result := TUusiPeli.Create(PakettiTaulu, PaketinKoko);
      PelinTarkemmatTiedotTyyppi: Result := TPelinTarkemmatTiedot.Create(XMLPaketti);
      LiityitPeliinTyyppi: Result := TLiityitPeliin.Create(XMLPaketti); }
      LiittyiPeliinTyyppi: Kasittelija(TLiittyiPeliin.Create(XMLPaketti));
      PeliAlkaaTyyppi: Kasittelija(TPeliAlkaa.Create(XMLPaketti));
   {   KenenVuoroTyyppi: Result := TKenenVuoro.Create(PakettiTaulu, PaketinKoko);
      HeitonTulosTyyppi: Result := THeitonTulos.Create(PakettiTaulu, PaketinKoko);
      OdotaTyyppi: Result := TOdota.Create(PakettiTaulu, PaketinKoko);
      KysymysTyyppi: Result := TKysymys.Create(PakettiTaulu, PaketinKoko);
      TulosTyyppi: Result := TTulos.Create(PakettiTaulu, PaketinKoko);
   }  PeliPaattyiTyyppi: Kasittelija(TPeliPaattyi.Create(XMLPaketti));
   {  VirhePakettiTyyppi: Result := TVirhePaketti.Create(PakettiTaulu, PaketinKoko);
      PelinTiedostotTyyppi: Result := TPelinTiedostot.Create(XMLPaketti); }
      PoistuiTyyppi: Kasittelija(TPoistui.Create(XMLPaketti));
    end;
  end;
  FreeAndNil(XMLPakettiLista);
end;

//Otetaan metasocket talteen viestin lhetyst varten
procedure TFormOdotushuone.AsetaMetaSocket(Meta: TClientSocket);
begin
  Self.Meta := Meta;
end;

{ Jos palvelin poistuu, peli pttyy ennenkuin alkoikaan.
muuten laitetaan viesti omasta poistumisesta }
procedure TFormOdotushuone.BitBtnPeruutaClick(Sender: TObject);
var I: Integer; PelaajaStringList: TStringList;
begin
  Sulje := True;
  Tulos := False;
  Close;
{  if (Palvelin and Verkossa) then
  begin
    PelaajaStringList := TStringList.Create;
    for I := 0 to Pelaajia-1 do
    begin
      PelaajaStringList.Add((PelaajaLista.Items[I] as THahmo).Tunnus);
    end;
    Laheta(TPeliPaattyi.Create(PelaajaStringList), Meta.Socket);
  end; }
end;

//Otetaan omat tiedot talteen
procedure TFormOdotushuone.LaitaOmatTiedot(OmaNimi, OmaTunnus: String);
begin
  Self.OmaNimi := OmaNimi;
  Self.OmaTunnus := OmaTunnus;
end;

//Keskitetn formi luonnissa ja varmistetaan ettei kukaan sulje sit vrin
procedure TFormOdotushuone.FormCreate(Sender: TObject);
begin
  Sulje := False;
  Left := (Screen.Width div 2) - (Width div 2);
  Top := (Screen.Height div 2) - (Height div 2);
end;

//Peli alkaa, suljetaan formi ja laitetaan tulokseksi aloittava.
procedure TFormOdotushuone.BitBtnAloitaPeliClick(Sender: TObject);
begin
  Sulje := True;
  Tulos := True;
  Close;
end;

//varmistetaan ettei kukaan voi sulkea formia vrin. Sammutuksen yhteydess
//pistetn pohjelma ksittelemn formi.
procedure TFormOdotushuone.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := False;
  if Sulje then
  begin
    CanClose := True;
    FormPelinPelaaminen.KasitteleOdotushuone;
  end;
end;

//Vapautetaan objectlistit tuhoamisessa
procedure TFormOdotushuone.FormDestroy(Sender: TObject);
begin
  FreeAndNil(Kysymyssarjat);
  FreeAndNil(PelaajaLista);
end;

//Otetaan chat talteen
procedure TFormOdotushuone.AsetaChat(Chat: TFormChat);
begin
  ChatIkkuna := Chat;
end;

{Pakotetaan pelaajat odottamaan kun tapahtuu muutos (joku liittyy/poistuu)
Tll pyritn vlttmn virheit pelaajalistassa. }
procedure TFormOdotushuone.OdotaHetki;
begin
  TimerPakollinenOdotus.Enabled := True;
  BitBtnAloitaPeli.Enabled := False;
  BitBtnPeruuta.Enabled := False;
end;

//Kun odotus on ohi, sallitaan pelin kynnistminen ja peruuttaminen.
procedure TFormOdotushuone.TimerPakollinenOdotusTimer(Sender: TObject);
begin
  BitBtnAloitaPeli.Enabled := True;
  BitBtnPeruuta.Enabled := True;
  TimerPakollinenOdotus.Enabled := False;
end;

//Lhett pelaajan 2 poistoviestin pelilogiikalle
procedure TFormOdotushuone.ButtonPoistaPelaaja2Click(Sender: TObject);
begin
  Laheta(TPoistui.Create(THahmo(PelaajaLista[1]).Nimi, THahmo(PelaajaLista[1]).Tunnus), ClientSocketPeli.Socket);
end;

//Lhett pelaajan 3 poistoviestin pelilogiikalle
procedure TFormOdotushuone.ButtonPoistaPelaaja3Click(Sender: TObject);
begin
  Laheta(TPoistui.Create(THahmo(PelaajaLista[2]).Nimi, THahmo(PelaajaLista[2]).Tunnus), ClientSocketPeli.Socket);
end;

//Lhett pelaajan 4 poistoviestin pelilogiikalle
procedure TFormOdotushuone.ButtonPoistaPelaaja4Click(Sender: TObject);
begin
  Laheta(TPoistui.Create(THahmo(PelaajaLista[3]).Nimi, THahmo(PelaajaLista[3]).Tunnus), ClientSocketPeli.Socket);
end;

end.
