{
  Unit sislt tietorakenteen, johon tallennetaan pelaajien kysymyksiin
  esittmns vastaukset. Opettajan kyttliittym hydynt nit
  luokkia.

  Tekijt:
    Heikki Nevala

  Luotu: 29.11.2005
  Viimeksi muokattu: 29.11.2005
}

unit PelaajaVastaukset;

interface

uses SysUtils, Classes, Contnrs;

type
  // Pelaajakohtaiset kysymysten vastaukset
  TPelaajanVastaukset = class
    private
      FNimi, FTunnus: string; // Pelaajan nimi
      FVastaukset : TObjectlist;
    public
      Constructor Create();
      Destructor Destroy; Override;

    published
      property nimi : string read FNimi write FNimi;
      property tunnus : string read FTunnus write FTunnus;
      property Vastaukset : TObjectlist read FVastaukset write FVastaukset;
  end;

  // Kysymyskohtaiset kysymys ja thn annettu vastaus, sek monivalintojen
  // yhteydess arvo sille, menik vastaus oikein vai ei
  TKysymyksenVastaus = class
    private
      FKysymys : string;
      FVastaus : string;
      FOikea : string;
      FOikein : boolean;
      FPisteet : integer;
      FSarja : integer;
      FKysymysNumero : integer;
    public
    published
      property Kysymys : string read FKysymys write FKysymys;
      property Vastaus : string read FVastaus write FVastaus;
      property OikeaVastaus: string read FOikea write FOikea;
      property Oikein : Boolean read FOikein write FOikein;
      property SarjaNumero : integer read FSarja write FSarja;
      property KysymysNumero : integer read FKysymysNumero write FKysymysNumero;
      property Pisteet : integer read FPisteet write FPisteet;
  end;


implementation

{ TPelaajanVastaukset }

constructor TPelaajanVastaukset.Create;
begin
  Vastaukset:=TObjectlist.Create;
end;

destructor TPelaajanVastaukset.Destroy;
begin
  Vastaukset.Free;
  inherited;
end;

end.
