unit SisallonpoistoForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdFTP, IdFTPList;

type
  TFormSisallonPoistaminen = class(TForm)
    ListBoxPelilaudat: TListBox;
    ListBoxKysymyssarjat: TListBox;
    ButtonPoistaPelilautoja: TButton;
    ButtonPoistaKysymyssarjoja: TButton;
    LabelPelilaudat: TLabel;
    LabelKysymyssarjat: TLabel;
  private
    FTPClientTiedostopalvelin: TIdFTP;
  public
    procedure Alusta(FTPClientTiedostopalvelin: TIdFTP);

    destructor Destroy; override;
  end;

var
  FormSisallonPoistaminen: TFormSisallonPoistaminen;

implementation

{$R *.dfm}

{ TFormSisallonPoistaminen }

procedure TFormSisallonPoistaminen.Alusta(FTPClientTiedostopalvelin: TIdFTP);
var TiedostolistaTekstit: TStringList;
    Tiedostolista: TIdFTPListItems;
    I: Integer;

//    testistring: String;
//    testiinteger: Integer;
begin
  Self.FTPClientTiedostopalvelin := FTPClientTiedostopalvelin;

  if(FTPClientTiedostopalvelin.Connected = False) then
    FTPClientTiedostopalvelin.Connect;

  if(FTPClientTiedostopalvelin.Connected = False) then exit;

  //siirrytn pelilautojen hakemistoon
  FTPClientTiedostopalvelin.ChangeDir('Pelilaudat');

  //haetaan pelilaudat
  TiedostolistaTekstit := TStringList.Create;
  FTPClientTiedostopalvelin.List(TiedostolistaTekstit, '*.pla');

  Tiedostolista := TIdFTPListItems.Create;
  Tiedostolista.ListFormat := flfDos;
  Tiedostolista.LoadList(TiedostolistaTekstit);

  for I := 0 to Tiedostolista.Count - 1 do
  begin
    ListBoxPelilaudat.Items.Add(Tiedostolista.Items[I].FileName);
  end;

  //siirrytn takaisin tiedostopalvelimen juurihakemistoon
  FTPClientTiedostopalvelin.ChangeDir('..');

  //siirrytn kysymyssarjojen hakemistoon
  FTPClientTiedostopalvelin.ChangeDir('Kysymyssarjat');

  TiedostolistaTekstit := TStringList.Create;
  FTPClientTiedostopalvelin.List(TiedostolistaTekstit, '*.kys');

  Tiedostolista := TIdFTPListItems.Create;
  Tiedostolista.ListFormat := flfDos;
  Tiedostolista.LoadList(TiedostolistaTekstit);

  for I := 0 to Tiedostolista.Count - 1 do
  begin
    ListBoxKysymyssarjat.Items.Add(Tiedostolista.Items[I].FileName);
  end;
end;

destructor TFormSisallonPoistaminen.Destroy;
begin
  FTPClientTiedostopalvelin.Quit;

  inherited Destroy;
end;

end.
