// TALARIUS

// Formi, josta kyttj saa valita pelilaudalle liitettvn taustakuvan
// asettelun tavan.

// Tekijt:
//   Antti Kirjavainen (ajkirjav@iki.fi)
//   Jukka Miettinen (jupemiet@cc.jyu.fi)
//   Heikki Nevala (hemaneva@cc.jyu.fi)

unit TaustakuvanAsettaminenForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TFormTaustanAsettaminen = class(TForm)
    RadioGroupAsettelu: TRadioGroup;
    ButtonOK: TButton;
    ButtonPeruuta: TButton;
    procedure ButtonOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public
   
  end;

var
  FormTaustanAsettaminen: TFormTaustanAsettaminen;

implementation

uses PelilaudanTekoPaaForm;

{$R *.dfm}

procedure TFormTaustanAsettaminen.ButtonOKClick(Sender: TObject);
begin
  // ItemIndex kertoo asettelutyylin pformille
  FormPelilaudanTeko.AsetaTaustakuva(TTaustanAsettelu(RadioGroupAsettelu.ItemIndex));
end;

procedure TFormTaustanAsettaminen.FormCreate(Sender: TObject);
begin
  // Synnytetn formi keskelle ruutua
  Left := (Screen.Width div 2) - (Width div 2);
  Top := (Screen.Height div 2) - (Height div 2);
end;

end.
