unit Tiedostopalvelin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPServer, IdFTPServer,
  StdCtrls, IdTCPConnection, IdTCPClient, IdFTP, IdUserAccounts, IdFTPList,
  IdException, StrUtils, ScktComp, Paketit, XMLDoc, XMLIntf, xmldom;

type
  TFormTiedostopalvelin = class(TForm)
    IdFTP1: TIdFTP;
    Button1: TButton;
    Label2: TLabel;
    Label4: TLabel;
    Label1: TLabel;
    Button3: TButton;
    Label3: TLabel;
    Button4: TButton;
    Label5: TLabel;
    Button2: TButton;
    Button5: TButton;
    Label6: TLabel;
    IdFTPServer1: TIdFTPServer;
    Label7: TLabel;
    ClientSocketMetapalvelin: TClientSocket;
    Button6: TButton;
    procedure Button1Click(Sender: TObject);
    procedure IdFTPServer1Connect(AThread: TIdPeerThread);
    procedure IdFTPServer1AfterUserLogin(ASender: TIdFTPServerThread);
    procedure IdFTP1AfterClientLogin(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure IdFTP1Connected(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure IdFTPServer1BeforeCommandHandler(ASender: TIdTCPServer;
      const AData: String; AThread: TIdPeerThread);
    procedure IdFTP1Status(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: String);
    procedure Button3Click(Sender: TObject);
    procedure IdFTPServer1UserLogin(ASender: TIdFTPServerThread;
      const AUsername, APassword: String; var AAuthenticated: Boolean);
    procedure IdFTPServer1ListDirectory(ASender: TIdFTPServerThread;
      const APath: String; ADirectoryListing: TIdFTPListItems);
    procedure Button4Click(Sender: TObject);
    procedure IdUserManager1AfterAuthentication(const AUsername,
      APassword: String; AAuthenticationResult: Boolean);
    procedure IdFTPServer1Exception(AThread: TIdPeerThread;
      AException: Exception);
    procedure IdFTPServer1AfterCommandHandler(ASender: TIdTCPServer;
      AThread: TIdPeerThread);
    procedure IdFTP1AfterGet(ASender: TObject; VStream: TStream);
    procedure IdFTPServer1ChangeDirectory(ASender: TIdFTPServerThread;
      var VDirectory: String);
    procedure IdFTPServer1RetrieveFile(ASender: TIdFTPServerThread;
      const AFileName: String; var VStream: TStream);
    procedure Button5Click(Sender: TObject);
    procedure IdFTPServer1StoreFile(ASender: TIdFTPServerThread;
      const AFileName: String; AAppend: Boolean; var VStream: TStream);
    procedure ClientSocketMetapalvelinRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormDestroy(Sender: TObject);
    procedure ClientSocketMetapalvelinConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketMetapalvelinConnecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Button6Click(Sender: TObject);
  private
    Tunnukset: TStringList;
    SalasanatMD5: TStringList;

    procedure LahetaPaketti(Paketti: TPaketti);

    procedure PyydetytTunnukset(Paketti: TTunnusLista);
    procedure LisattyTunnus(Paketti: TLisattyTunnus);
  public
    { Public declarations }
  end;

var
  FormTiedostopalvelin: TFormTiedostopalvelin;

implementation

{$R *.dfm}

procedure TFormTiedostopalvelin.Button1Click(Sender: TObject);
begin
  IdFTP1.Connect;
end;

procedure TFormTiedostopalvelin.IdFTPServer1Connect(AThread: TIdPeerThread);
var I: Integer;
begin
//   Label5.Caption := 'C';
  I := 0;
end;

procedure TFormTiedostopalvelin.IdFTPServer1AfterUserLogin(ASender: TIdFTPServerThread);
var I: Integer;
begin
//  Label5.Caption := 'L';
  I := 0;
end;

procedure TFormTiedostopalvelin.IdFTP1AfterClientLogin(Sender: TObject);
var I: Integer;
begin
  I := 0;
end;

procedure TFormTiedostopalvelin.FormCreate(Sender: TObject);
var I: Integer;
begin
  IdFTP1.Username := 'tunnus';
  IdFTP1.Password := 'kala';
  IdFTP1.Host := 'localhost';
  IdFTP1.Port := 5002;

  IdFTPServer1.Active := False;
  IdFTPServer1.DefaultPort := 5002;
  IdFTPServer1.DefaultDataPort := 5004;
  IdFTPServer1.Active := True;

//  ClientSocketMetapalvelin := TClientSocket.Create(Self);

//  ClientSocketMetapalvelin.Host := 'localhost';
//  ClientSocketMetapalvelin.Port := 5001;
//  ClientSocketMetapalvelin.Active := True;

  ClientSocketMetapalvelin.Open;
end;

procedure TFormTiedostopalvelin.IdFTP1Connected(Sender: TObject);
var I: Integer;
begin
  //Label2.Caption := 'C';
  I := 0;
end;

procedure TFormTiedostopalvelin.Button2Click(Sender: TObject);
var stream: TMemoryStream;
begin
  stream := TMemoryStream.Create;

  try
    IdFTP1.Get('testi.txt', stream, False);
    if(stream.Size > 0) then
      stream.SaveToFile('testi1.txt');
  except
    on EIdProtocolReplyError do
    begin
    end;
  end;

  stream.Free;
end;

procedure TFormTiedostopalvelin.IdFTPServer1BeforeCommandHandler(ASender: TIdTCPServer;
  const AData: String; AThread: TIdPeerThread);
var I: Integer;
begin
  I := 0;
end;

procedure TFormTiedostopalvelin.IdFTP1Status(ASender: TObject; const AStatus: TIdStatus;
  const AStatusText: String);
var I: Integer;
begin
  I := 0;
end;

procedure TFormTiedostopalvelin.Button3Click(Sender: TObject);
var sisalto: TStringList;
    lista: TIdFTPListItems;
    I: Integer;
    s: String;
    tied: TIdFTPListItem;
begin
//  IdFTP1.ChangeDir('Pelilaudat');
  Label1.Caption := IdFTP1.RetrieveCurrentDir;

  sisalto := TStringList.Create;

  IdFTP1.List(sisalto, '*.*');
  lista := TIdFTPListItems.Create;
  lista.ListFormat := flfDos;
  lista.LoadList(sisalto);

  i:=0;
  Label3.Caption := '';
  for I := 0 to lista.Count - 1 do
  begin
    tied := lista.Items[I];
    Label3.Caption := Label3.Caption + tied.FileName +#13#10;
  end;
end;

procedure TFormTiedostopalvelin.IdFTPServer1UserLogin(ASender: TIdFTPServerThread;
  const AUsername, APassword: String; var AAuthenticated: Boolean);
var I: Integer;
begin
  for I := 0 to Tunnukset.Count - 1 do
  begin
    if((Tunnukset[I] = AUsername) and (SalasanatMD5[I] = APassword)) then
    begin
      AAuthenticated := True;
      Exit;
    end;
  end;

  if((AUsername = 'meta') and (APassword = 'salasana')) then
  begin
    AAuthenticated := True;
    Exit;
  end;

  AAuthenticated := False;
end;

procedure TFormTiedostopalvelin.IdFTPServer1ListDirectory(ASender: TIdFTPServerThread;
  const APath: String; ADirectoryListing: TIdFTPListItems);
var fileitem: TIdFTPListItem;
    Res: TSearchRec;
    EOFound: Boolean;
    Path: String;

    s : string;
begin
  EOFound:= False;

  if(AnsiEndsStr('\', APath)) then
  begin
    Path := LeftStr(APath, Length(APath) - 1);
  end;

  if(AnsiEndsStr('/', Path)) then
  begin
    Path := LeftStr(Path, Length(Path) - 1);
  end;

  s := '.\' + Path;
  if FindFirst(s, faAnyFile, Res) < 0 then
    exit
  else
    while not EOFound do begin
      fileitem := ADirectoryListing.Add;
      fileitem.FileName := Res.Name;
      fileitem.Size := Res.Size;

      EOFound:= FindNext(Res) <> 0;
    end;
  FindClose(Res);
end;

procedure TFormTiedostopalvelin.Button4Click(Sender: TObject);
begin
  IdFTP1.Disconnect;
end;

procedure TFormTiedostopalvelin.IdUserManager1AfterAuthentication(const AUsername,
  APassword: String; AAuthenticationResult: Boolean);
var I: Integer;
begin
  I := 0;
end;

procedure TFormTiedostopalvelin.IdFTPServer1Exception(AThread: TIdPeerThread;
  AException: Exception);
var I: Integer;
begin
  I := 0;
end;

procedure TFormTiedostopalvelin.IdFTPServer1AfterCommandHandler(ASender: TIdTCPServer;
  AThread: TIdPeerThread);
var I: Integer;
begin
  I := 0;
end;

procedure TFormTiedostopalvelin.IdFTP1AfterGet(ASender: TObject; VStream: TStream);
begin
//
end;

procedure TFormTiedostopalvelin.IdFTPServer1ChangeDirectory(ASender: TIdFTPServerThread;
  var VDirectory: String);
begin
//
end;

procedure TFormTiedostopalvelin.IdFTPServer1RetrieveFile(ASender: TIdFTPServerThread;
  const AFileName: String; var VStream: TStream);
begin
  try
    VStream := TFileStream.Create(AFileName, fmOpenRead);
  except
    on EFOpenError do
    begin
      
    end;
  end;
end;

procedure TFormTiedostopalvelin.Button5Click(Sender: TObject);
var stream: TFileStream;
begin
  IdFTP1.Put('testi.txt', 'ltesti1.txt');
end;

procedure TFormTiedostopalvelin.IdFTPServer1StoreFile(ASender: TIdFTPServerThread;
  const AFileName: String; AAppend: Boolean; var VStream: TStream);
begin
  VStream := TFileStream.Create(AFileName, fmCreate);
end;

procedure TFormTiedostopalvelin.ClientSocketMetapalvelinRead(Sender: TObject;
  Socket: TCustomWinSocket);
var PaketinTyyppi: Pakettityyppi;
    XMLPaketti: String;
    XMLPakettiLista: TStringList;
    I: Integer;
begin
  XMLPaketti := Socket.ReceiveText;
  if XMLPaketti = '' then begin
    exit;
  end;

  XMLPakettiLista := PilkoXML(XMLPaketti);

  for I := XMLPakettiLista.Count-1 downto 0 do
  begin
    XMLPaketti := XMLPakettiLista[I];
    PaketinTyyppi := PalautaPaketinTyyppi(XMLPaketti);
    case PaketinTyyppi of
      TunnusListaTyyppi:
        PyydetytTunnukset(TTunnusLista.Create(XMLPaketti));
      LisattyTunnusTyyppi:
        LisattyTunnus(TLisattyTunnus.Create(XMLPaketti));
    end;
  end;
end;

procedure TFormTiedostopalvelin.FormDestroy(Sender: TObject);
begin
  ClientSocketMetapalvelin.Close;
end;

procedure TFormTiedostopalvelin.PyydetytTunnukset(Paketti: TTunnusLista);
begin
  Tunnukset.AddStrings(Paketti.Tunnukset);
  SalasanatMD5.AddStrings(Paketti.SalasanatMD5);

  Paketti.Free;

  Label7.Caption := IntToStr(Tunnukset.Count);
end;

procedure TFormTiedostopalvelin.LisattyTunnus(Paketti: TLisattyTunnus);
begin
  if(Tunnukset = nil) then
    Tunnukset := TStringList.Create;

  if(SalasanatMD5 = nil) then
    SalasanatMD5 := TStringList.Create;

  Tunnukset.Add(Paketti.Tunnus);
  SalasanatMD5.Add(Paketti.SalasanaMD5);

  Paketti.Free;

  Label7.Caption := IntToStr(Tunnukset.Count);
end;

procedure TFormTiedostopalvelin.LahetaPaketti(Paketti: TPaketti);
begin
    ClientSocketMetapalvelin.Socket.SendText(Paketti.PalautaPaketti);
end;

procedure TFormTiedostopalvelin.ClientSocketMetapalvelinConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var I: Integer;
begin
  I := 0;
end;

procedure TFormTiedostopalvelin.ClientSocketMetapalvelinConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
var I: Integer;
begin
  I := 0;
end;

procedure TFormTiedostopalvelin.Button6Click(Sender: TObject);
begin
  LahetaPaketti(TPing.Create);

  LahetaPaketti(TKirjaaTiedostopalvelimeksi.Create);

  LahetaPaketti(TAnnaTunnusLista.Create);
end;

end.
